      subroutine adjust_block(tb,ise,nx,id_abk)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      type(blocks) :: tb
      integer :: ise,nx,ib,ista,iend,i,k,it,iup,idw,nbki,mem0,mem1,
     &           nbk0,ix,ix1,ix2,max_up,min_up,max_dw,min_dw,id_abk,ih
      integer,allocatable :: ibud(:,:),ibud0(:)
      type(bkdiago),allocatable :: bkt(:)

      ih=1

      max_up=min(maxval(bk(:,ise,ih)%up)+1,maxval(iud(:,1))*(nx+1),
     &           limup)
      min_up=max(minval(bk(:,ise,ih)%up)-1,0)
      max_dw=min(maxval(bk(:,ise,ih)%dw)+1,maxval(iud(:,2))*(nx+1),
     &           limdw)
      min_dw=max(minval(bk(:,ise,ih)%dw)-1,0)

      nbki=nbk

      nbk0=0
!$OMP PARALLEL DO PRIVATE(iup,idw) REDUCTION(+:nbk0)
      do ib=1,block(ise,nx-1,mh)%nbk
        do i=1,nfr
          iup=block(ise,nx-1,mh)%nud(ib,1)+iud(i,1)
          idw=block(ise,nx-1,mh)%nud(ib,2)+iud(i,2)
          if(iup.ge.min_up.and.iup.le.max_up.and.
     &       idw.ge.min_dw.and.idw.le.max_dw) then
            nbk0=nbk0+1
          end if
        enddo
      enddo

      allocate(ibud(nbk0,3),ibud0(nbk0))

      nbk0=0
      do ib=1,block(ise,nx-1,mh)%nbk
        do i=1,nfr
          iup=block(ise,nx-1,mh)%nud(ib,1)+iud(i,1)
          idw=block(ise,nx-1,mh)%nud(ib,2)+iud(i,2)
          if(iup.ge.min_up.and.iup.le.max_up.and.
     &       idw.ge.min_dw.and.idw.le.max_dw) then
            nbk0=nbk0+1
            ibud(nbk0,1)=i
            ibud(nbk0,2)=ib
            ibud0(nbk0)=idw+ishft(iup,16)
          end if
        enddo
      enddo

      do i=1,2
        ibud(:,3)=ibud0
        ierr=ise-1
        call sortii(nbk0,ibud(:,3),ibud(:,i),ierr)
      enddo

      deallocate(ibud0)

      nbk=0
!$OMP PARALLEL DO REDUCTION(+:nbk)
      do ib=2,nbk0
        if(ibud(ib-1,3).ne.ibud(ib,3)) then
          nbk=nbk+1
        end if
      enddo
      nbk=nbk+1

      allocate(bkt(nbk))
!$OMP PARALLEL DO
      do ib=1,nbk
        allocate(bkt(ib)%ap(nfr))
        do i=1,nfr
          allocate(bkt(ib)%ap(i)%nse(2))
          bkt(ib)%ap(i)%nse=0
        enddo
      enddo

      nbk=1
      do ib=2,nbk0
        bkt(nbk)%ap(ibud(ib-1,1))%nse(ise)=ibud(ib-1,2)
        if(ibud(ib-1,3).ne.ibud(ib,3)) then
          bkt(nbk)%up=ishft(ibud(ib-1,3),-16)
          bkt(nbk)%dw=iand(ibud(ib-1,3),2**16-1)
          nbk=nbk+1
        end if
      enddo
      bkt(nbk)%ap(ibud(nbk0,1))%nse(ise)=ibud(nbk0,2)
      bkt(nbk)%up=ishft(ibud(nbk0,3),-16)
      bkt(nbk)%dw=iand(ibud(nbk0,3),2**16-1)

!$OMP PARALLEL DO PRIVATE(ix)
      do ib=1,nbk
        ix=0
        allocate(bkt(ib)%sizex(nfr))
        bkt(ib)%sizex=0
        do i=1,nfr
          if(bkt(ib)%ap(i)%nse(ise).ne.0) then
            ix=ix
     &        +block(ise,nx-1,mh)%size(bkt(ib)%ap(i)%nse(ise))
            bkt(ib)%sizex(i)
     &        =block(ise,nx-1,mh)%size(bkt(ib)%ap(i)%nse(ise))
          end if
        enddo
        bkt(ib)%size=ix
      enddo

!$OMP PARALLEL DO
      do ib=1,nbk
        allocate(bkt(ib)%stax(nfr),bkt(ib)%endx(nfr))
        bkt(ib)%stax(1)=1
        do i=1,nfr-1
          bkt(ib)%endx(i)=bkt(ib)%stax(i)+bkt(ib)%sizex(i)-1
          bkt(ib)%stax(i+1)=bkt(ib)%endx(i)+1
        enddo
        bkt(ib)%endx(nfr)=bkt(ib)%stax(nfr)+bkt(ib)%sizex(nfr)-1
      enddo

!$OMP PARALLEL DO
      do ib=1,nbk
        allocate(bkt(ib)%ibs(-1:1,nop))
        bkt(ib)%ibs=0
        do it=1,nop
          bkt(ib)%ibs(0,it)=ib
        enddo
      enddo
!$OMP PARALLEL DO
      do ix1=1,nbk
        do ix2=1,nbk
          do it=1,nop
            if(bkt(ix1)%up-nch(1,it).eq.bkt(ix2)%up.and.
     &         bkt(ix1)%dw-nch(2,it).eq.bkt(ix2)%dw) then
              bkt(ix1)%ibs(1,it)=ix2
            end if
            if(bkt(ix1)%up+nch(1,it).eq.bkt(ix2)%up.and.
     &         bkt(ix1)%dw+nch(2,it).eq.bkt(ix2)%dw) then
              bkt(ix1)%ibs(-1,it)=ix2
            end if
          enddo
        enddo
      enddo

C --- RESET PARALLELIZATION PARAMETERS
      call init_mpi_bk(1)

C --- MAKE ARRAY OF BLOCK INFOMATION
      if(allocated(tb%b)) then
        mem0=0; mem1=0
!$OMP PARALLEL DO REDUCTION(+:mem0,mem1)
        do ib=1,tb%nbk
          do i=1,nfr
            if(allocated(tb%b(ib)%s(i)%uv)) then
              mem0=mem0+8*size(tb%b(ib)%s(i)%uv)
            end if
          enddo
          if(allocated(tb%b(ib)%hm)) then
            mem1=mem1+8*size(tb%b(ib)%hm)
          end if
        enddo
        mem_uv=mem_uv-mem0
        mem_hm=mem_hm-(1+2*id_hop)*mem1
      end if

      if(allocated(tb%nud)) deallocate(tb%nud)
      if(allocated(tb%b2b)) deallocate(tb%b2b)
      if(allocated(tb%size)) deallocate(tb%size)
      if(allocated(tb%size0)) deallocate(tb%size0)
      if(allocated(tb%sizex)) deallocate(tb%sizex)
      if(allocated(tb%stax)) deallocate(tb%stax)
      if(allocated(tb%nse)) deallocate(tb%nse)
      if(allocated(tb%b)) deallocate(tb%b)
      if(allocated(tb%kid)) deallocate(tb%kid)

      if(allocated(tb%ista0)) deallocate(tb%ista0)
      if(allocated(tb%iend0)) deallocate(tb%iend0)
      if(allocated(tb%isize0))
     &  deallocate(tb%isize0)

      if(allocated(tb%ista)) deallocate(tb%ista)
      if(allocated(tb%iend)) deallocate(tb%iend)
      if(allocated(tb%isize))
     &  deallocate(tb%isize)

      if(allocated(tb%chbk)) deallocate(tb%chbk)
      if(allocated(tb%ichbk)) deallocate(tb%ichbk)

      allocate(tb%nud(nbk,2),
     &         tb%b2b(nbk,-1:1,nop),
     &         tb%size(nbk),
     &         tb%size0(nbk),
     &         tb%sizex(nbk,nfr),
     &         tb%stax(nbk,nfr),
     &         tb%b(nbk),
     &         tb%nse(nbk,nfr),
     &         tb%kid(nbk),
     &         tb%ista0(nbk,2),
     &         tb%iend0(nbk,2),
     &         tb%isize0(nbk,2),
     &         tb%ista(nbk,2),
     &         tb%iend(nbk,2),
     &         tb%isize(nbk,2),
     &         tb%chbk(nbk),
     &         tb%ichbk(nbki))

      tb%nbk=nbk
      tb%ndmx=sum(bkt(1:nbk)%size)
      tb%isbk=isbk0
      tb%iebk=iebk0
      tb%isbk1=isbk1
      tb%iebk1=iebk1
      tb%isbk2=isbk2
      tb%iebk2=iebk2
      tb%isbk3=isbk3
      tb%iebk3=iebk3
      tb%isbk4=isbk4
      tb%iebk4=iebk4

!$OMP PARALLEL DO PRIVATE(ista,iend)
      do ib=1,nbk
        tb%size0(ib)=bkt(ib)%size

        tb%kid(ib)=kid0(ib)

        call para_range(1,bkt(ib)%size,np_sys,myid_sys,ista,iend)
        tb%ista0(ib,1)=ista
        tb%iend0(ib,1)=iend
        tb%isize0(ib,1)=iend-ista+1
        call para_range(1,bkt(ib)%size,np_env,myid_env,ista,iend)
        tb%ista0(ib,2)=ista
        tb%iend0(ib,2)=iend
        tb%isize0(ib,2)=iend-ista+1

        do it=1,nop
          tb%b2b(ib,-1,it)=bkt(ib)%ibs(-1,it)
        enddo
        do it=1,nop
          tb%b2b(ib,0,it)=ib
        enddo
        do it=1,nop
          tb%b2b(ib,1,it)=bkt(ib)%ibs(1,it)
        enddo

        tb%nud(ib,1)=bkt(ib)%up
        tb%nud(ib,2)=bkt(ib)%dw

        if(ise.eq.1) then
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              tb%nse(ib,i)=bkt(ib)%ap(ad(i,k))%nse(ise)
              if(bkt(ib)%ap(ad(i,k))%nse(ise).ne.0) exit
            enddo
          enddo
        elseif(ise.eq.2) then
          do k=1,nfrx(2)
            do i=1,nfrx(1)
              tb%nse(ib,k)=bkt(ib)%ap(ad(i,k))%nse(ise)
              if(bkt(ib)%ap(ad(i,k))%nse(ise).ne.0) exit
            enddo
          enddo
        end if

        do i=1,nfr
          tb%sizex(ib,i)=bkt(ib)%sizex(i)
          tb%stax(ib,i)=bkt(ib)%stax(i)
        enddo

        tb%chbk(ib)=0
        do ix=1,nbki
          if(bk(ix,ise,ih)%up.eq.tb%nud(ib,1).and.
     &       bk(ix,ise,ih)%dw.eq.tb%nud(ib,2)) then
            tb%chbk(ib)=ix
          end if
        enddo
      enddo

!$OMP PARALLEL DO
      do ib=1,nbk
        if(tb%chbk(ib).eq.0) cycle
        tb%ichbk(tb%chbk(ib))=ib
      enddo

      if(myid_dmrg.eq.key_rank) then
        write(iso,'(2x,a,I0,a,I0)')
     &    '(number of blocks): ',nbki,' --> ',nbk
      end if

      if(nbki.eq.nbk) then
        id_abk=0
      else
        id_abk=1
      end if

      return
      end
