      subroutine cpara(para,is,ih,nhx)
      use mod_dmrg
      implicit none
      integer :: ip,is,ih,ix,nhx,nvi
      real(8) :: vtemp
      character(256) :: para

      if(index(para,'end').ne.0.or.index(para,'END').ne.0) then
        is=2
        return
      end if

      if(index(para,'!').eq.1) then
        is=1
        return
      end if

      ip=index(para,'#')
      if(ip.ne.0) then
        if(index(para,'2').ne.0) then !2-body
          ih=2
        end if

        if(index(para,'4').ne.0) then !4-body
          ih=4
        end if

        if(index(para,'M').ne.0) then !magnetic field
          ih=11
        end if

        ip=index(para,'C')
        if(ip.ne.0) then
          ip=index(para,'t')
          ip=index(para(ip+1:),'=')+ip
          read(para(ip+1:),*) vtemp
          ip=index(para,'N')
          ip=index(para(ip+1:),'=')+ip
          read(para(ip+1:),*) nsite
          if(allocated(hamil)) then
            do ix=1,nsite-1
              nhx=nhx+1
              hamil(nhx)%nop=2
              hamil(nhx)%vh(1)=vtemp
              allocate(hamil(nhx)%ihs(2))
              hamil(nhx)%ihs(1)=ix
              hamil(nhx)%ihs(2)=ix+1
            enddo
          else
            do ix=1,nsite-1
              nhx=nhx+1
              i2v(nhx)=1
            enddo
          end if
          nh2=nh2+nsite-1
        end if

        ip=index(para,'E')
        if(ip.ne.0) then
          if(allocated(hamil)) then
            ip=index(para,'=')
            read(para(ip+1:),*) vtemp
            do ix=1,nsite
              nhx=nhx+1
              hamil(nhx)%nop=2
              hamil(nhx)%vh(1)=vtemp
              allocate(hamil(nhx)%ihs(2))
              hamil(nhx)%ihs(1:2)=ix
            enddo
          end if
          nh2=nh2+nsite
        end if

        ip=index(para,'U')
        if(ip.ne.0) then
          if(allocated(hamil)) then
            ip=index(para,'=')
            read(para(ip+1:),*) vtemp
            do ix=1,nsite
              nhx=nhx+1
              hamil(nhx)%nop=4
              hamil(nhx)%vh(1)=vtemp
              allocate(hamil(nhx)%ihs(4))
              hamil(nhx)%ihs(1:4)=ix
            enddo
          end if
          nh4=nh4+nsite
        end if

        ip=index(para,'V')
        if(ip.ne.0) then
          if(allocated(hamil)) then
            ip=index(para,'=')
            read(para(ip+1:),*) vtemp
            nvi=0
            do ix=1,nh2
              if(i2v(ix).eq.1) then
                nvi=nvi+1
                nhx=nhx+1
                hamil(nhx)%nop=4
                hamil(nhx)%vh(1)=vtemp
                allocate(hamil(nhx)%ihs(4))
                hamil(nhx)%ihs(1:2)=hamil(ix)%ihs(1)
                hamil(nhx)%ihs(3:4)=hamil(ix)%ihs(2)
              end if
            enddo
          else
            nvi=0
            do ix=1,nh2
              if(i2v(ix).eq.1) nvi=nvi+1
            enddo
          end if
          nh4=nh4+nvi
        end if

        is=1
        return
      end if

      is=0

      return
      end
