      subroutine ex_space(mb,ise,tb)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ise,ib,jb,iop0,iop,jop,it,msi,i1,i2
      integer,allocatable :: msx(:),nsx(:,:),ksx(:,:),ktp(:),lop(:)
      real(8) :: bf,a0,a1
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: uv0(:,:)
      type(temp_array) :: mb(nbk)
      type(temp_array),allocatable :: nb(:)
      type(bop),allocatable :: tp(:)
      type(blocks) :: tb

      allocate(nb(nbk))
      do ib=1,nbk
        allocate(nb(ib)%uv(idisp2(myid_(2)+1,ib)+1:
     &                     idisp2(myid_(2)+1,ib)+ircnt2(myid_(2)+1,ib),
     &                     idisp1(myid_(1)+1,ib)+1:
     &                     idisp1(myid_(1)+1,ib)+ircnt1(myid_(1)+1,ib)))
!$OMP PARALLEL WORKSHARE
        nb(ib)%uv=zero
!$OMP END PARALLEL WORKSHARE
      enddo

      jop=0
!$OMP PARALLEL DO REDUCTION(+:jop)
      do iop=1,nh2,np_int
        if(hamil(iop)%ihs(1).lt.iad(1)+nas.and.
     &     hamil(iop)%ihs(2).gt.iad(2)-nae) then
          jop=jop+1
        end if
      enddo

      allocate(lop(jop))

      jop=0
      do iop=1,nh2,np_int
        if(hamil(iop)%ihs(1).lt.iad(1)+nas.and.
     &     hamil(iop)%ihs(2).gt.iad(2)-nae) then
          jop=jop+1
          lop(jop)=iop
        end if
      enddo

      do iop0=1,jop,np_int
        iop=lop(iop0)
        do it=1,nit
          msi=2   ! # of operators
          allocate(msx(4),nsx(msi,4),ksx(msi,4),tp(1),ktp(2))
          allocate(tp(1)%io(nfr),tp(1)%vo(nfr))
!$OMP PARALLEL WORKSHARE
          tp(1)%io(1:nfr)=0
          tp(1)%vo(1:nfr)=zero
          ktp=iht(:,it)
!$OMP END PARALLEL WORKSHARE
          call check_op(msi,hamil(iop)%ihs,ktp,msx,nsx,ksx,bf)

          if(ise.eq.1) then
            call make_operators(msx(1),nsx(:,1),ksx(:,1),tp(1),
     &                          one,-1.d0)
            call single_opx(msx(2),ksx(:,2),tp(1)%io,tp(1)%vo,
     &                      one)
          elseif(ise.eq.2) then
            call single_opx(msx(3),ksx(:,3),tp(1)%io,tp(1)%vo,
     &                      one)
            call make_operators(msx(4),nsx(:,4),ksx(:,4),tp(1),
     &                          one,-2.d0)
          end if

          do ib=isbk0,iebk0
            jb=tb%b2b(ib,(1-2*mod(ise,2)),abs(iht(1,it)))
            if(jb.eq.0) cycle
            do i1=1,nfrx(ise)
              if(tb%sizex(ib,i1).eq.0) cycle
              i2=tp(1)%io(i1)
              if(i2.eq.0) cycle
              if(tb%sizex(jb,i2).gt.0) then
                if(tb%chbk(ib).ne.0) then
                  call op_dm(1,msx,ise,ib,i1,jb,i2,nb,mb,
     &                       tp(1)%bt(tb%nse(ib,i1))%op,
     &                       tb%sizex(jb,i2),tb)
                end if
                if(ihm(it).eq.0) cycle
                if(tb%chbk(jb).ne.0) then
                  call op_dm(2,msx,ise,jb,i2,ib,i1,nb,mb,
     &                       tp(1)%bt(tb%nse(ib,i1))%op,
     &                       tb%sizex(jb,i2),tb)
                end if
              end if
            enddo
          enddo

          deallocate(msx,nsx,ksx,tp,ktp)
        enddo
      enddo

      do ib=1,nbk
        allocate(uv0(ircnt2(myid_(2)+1,ib),ircnt1(myid_(1)+1,ib)))
        call mpi_allreduce(nb(ib)%uv,uv0,
     &                     ircnt2(myid_(2)+1,ib)*ircnt1(myid_(1)+1,ib),
     &                     mpi_kv,mpi_sum,newcomm_int,ierr)
        if(ib.ge.isbk1.and.ib.le.iebk1) then
          call XAXPY(ircnt2(myid_(2)+1,ib)*ircnt1(myid_(1)+1,ib),
     &               one,uv0,1,mb(ib)%uv,1)
        elseif(allocated(mb(ib)%uv)) then
          deallocate(mb(ib)%uv)
        end if
        deallocate(uv0)
      enddo
      deallocate(nb)

! --- NORMALIZE
      a0=0.d0
!$OMP PARALLEL DO REDUCTION(+:a0)
      do ib=isbk1,iebk1
        do i1=1,ircnt1(myid_(1)+1,ib)
          do i2=1,ircnt2(myid_(2)+1,ib)
            if(i1+idisp1(myid_(1)+1,ib).eq.
     &         i2+idisp2(myid_(2)+1,ib)) then
              a0=a0+mb(ib)%uv(i2+idisp2(myid_(2)+1,ib),
     &                        i1+idisp1(myid_(1)+1,ib))
            end if
          enddo
        enddo
      enddo

      call mpi_allreduce(a0,a1,1,MPI_REAL8,mpi_sum,newcomm_dmrg,ierr)

      do ib=isbk1,iebk1
        call XSCAL(ircnt2(myid_(2)+1,ib)*ircnt1(myid_(1)+1,ib),
     &             1.d0/a1,mb(ib)%uv,1)
      enddo

      return
      end
