      subroutine init_mpi_vec(id)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: id,ib,i,ise,ih

      ih=1

! --- INITIALIZATION
      if(id.eq.1) then
!$OMP PARALLEL DO
        do ib=1,nbk
          do ise=1,2
            deallocate(bk(ib,ise,ih)%ivs,bk(ib,ise,ih)%ive,
     &                 bk(ib,ise,ih)%ircntv,bk(ib,ise,ih)%idispv)
          enddo
        enddo
      end if

! --- VECTOR PARALLELIZATION
      do ise=1,2
        do ib=1,nbk
          allocate(bk(ib,ise,ih)%ivs(nfr),bk(ib,ise,ih)%ive(nfr),
     &             bk(ib,ise,ih)%isz(nfr),
     &             bk(ib,ise,ih)%ircntv(np_(ise),nfr),
     &             bk(ib,ise,ih)%idispv(np_(ise),nfr))
          do i=1,nfrx(ise)
            call para_range(1,bk(ib,ise,ih)%sizex(i),np_(ise),
     &             myid_(ise),bk(ib,ise,ih)%ivs(i),bk(ib,ise,ih)%ive(i))
            bk(ib,ise,ih)%isz(i)
     &        =bk(ib,ise,ih)%ive(i)-bk(ib,ise,ih)%ivs(i)+1

            call para_info(1,bk(ib,ise,ih)%sizex(i),np_(ise),myid_(ise),
     &                     newcomm_(ise),bk(ib,ise,ih)%ircntv(:,i),
     &                     bk(ib,ise,ih)%idispv(:,i))
          enddo
        enddo
      enddo

      return
      end
