      subroutine init_vtmp(vin,vout)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: i,k,ib,ih
      type(avec) :: vin(isbk1:iebk1),vout(isbk0:iebk0)

      ih=1

      do ib=isbk0,iebk0
        allocate(vout(ib)%ap(nfrx(1)*nfrx(2)))
        do k=1,nfrx(2)
          do i=1,nfrx(1)
            if(bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1.gt.0.and.
     &         bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1.gt.0) then

              allocate(vout(ib)%ap(ad(i,k))
     &                 %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                    bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))

              if(myid_int.eq.kid1(ib)) then
!$OMP PARALLEL WORKSHARE
                vout(ib)%ap(ad(i,k))%b=vin(ib)%ap(ad(i,k))%b
!$OMP END PARALLEL WORKSHARE
              end if

              call mpi_bcast(vout(ib)%ap(ad(i,k))%b,
     &                       (bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                      *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                        mpi_kv,kid1(ib),newcomm_int,ierr)

              call mpi_bcast(vout(ib)%ap(ad(i,k))%b,
     &                       (bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                      *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                        mpi_kv,0,newcomm_vec,ierr)

            end if
          enddo
        enddo
      enddo

      return
      end
