      subroutine make_hamil_4s(iop,iop0,it)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iop,iop0,itx(4),it,ib,ix1,ix2,
     &           nx(2),num(4),ih
      real(8) :: bx(4),bf,hf
      integer,allocatable :: msx(:),nsx(:,:),ksx(:,:)

      ih=1

      allocate(kop(1,iop0)%io(nfr),kop(1,iop0)%vo(nfr),
     &         kop(2,iop0)%io(nfr),kop(2,iop0)%vo(nfr),
     &         kop(1,iop0)%jbk(nbk),
     &         kop(1,iop0)%fs(nfr),kop(2,iop0)%fs(nfr),
     &         msx(4),nsx(4,4),ksx(4,4),iex(4,2))

!$OMP PARALLEL WORKSHARE
      kop(1,iop0)%io=0
      kop(1,iop0)%vo=zero
      kop(2,iop0)%io=0
      kop(2,iop0)%vo=zero
      bx=1.d0
      iex=0
!$OMP END PARALLEL WORKSHARE

      call make_itx_4s(it,itx,th(1)%ic(iop0),hf)

      call check_op(4,hamil(iop)%ihs,itx,msx,nsx,ksx,bf)

      num=1

      if(msx(4).eq.0) then
        if(msx(3).eq.0) then
          th(1)%kh(iop0)=1
          bx(1)=bf*hamil(iop)%vh(1)*hf
        elseif(msx(1).eq.0) then !added--added
          th(1)%kh(iop0)=6
          bx(2)=bf*hamil(iop)%vh(1)*hf
        else
          th(1)%kh(iop0)=3
          bx(1)=bf*hamil(iop)%vh(1)*hf
        end if
      elseif(msx(1).eq.0) then
        if(msx(2).eq.0) then
          th(1)%kh(iop0)=2
          bx(4)=bf*hamil(iop)%vh(1)*hf
        else
          th(1)%kh(iop0)=4
          bx(4)=bf*hamil(iop)%vh(1)*hf
        end if
      else
        th(1)%kh(iop0)=5
        bx(1)=bf*hamil(iop)%vh(1)*hf
      end if

      call make_hamil_c4(iop0,num,msx,nsx,ksx,bx)

! --- BLOCK INFO. OF SPIN SECTOR
      nx=0
      do ix2=1,4
        if(hamil(iop)%ihs(ix2).lt.iad(1)+nas) then
          nx(abs(itx(ix2)))=nx(abs(itx(ix2)))+sign(1,itx(ix2))
        end if
      enddo
      do ib=1,nbk
        kop(1,iop0)%jbk(ib)=ib
        do ix1=1,2
          do ix2=1,abs(nx(ix1))
            if(kop(1,iop0)%jbk(ib).eq.0) exit
            kop(1,iop0)%jbk(ib)
     &        =bk(kop(1,iop0)%jbk(ib),1,ih)%ibs(-sign(1,nx(ix1)),ix1)
          enddo
        enddo
      enddo

! --- FERMION SING OF ADDED SITES
      do ix1=1,2
        nx=0
        do ix2=1,3,2
          if(hamil(iop)%ihs(ix2).lt.iad(ix1).and.
     &       hamil(iop)%ihs(ix2+1).gt.iad(ix1)) then
            nx(abs(itx(ix2)))=nx(abs(itx(ix2)))+1
          end if
        enddo

        if(iftp.eq.1) then
          do ix2=1,nfrx(ix1)
            kop(ix1,iop0)%fs(ix2)=(fsi(0)**(nx(1)*iud(ix2,1)))
     &                           *(fsi(0)**(nx(2)*iud(ix2,2)))
          enddo
        elseif(iftp.eq.2) then
          do ix2=1,nfrx(ix1)
            kop(ix1,iop0)%fs(ix2)=fsi(0)
     &        **((nx(1)+nx(2))*(iud(ix2,1)+iud(ix2,2)))
          enddo
        else
          do ix2=1,nfrx(ix1)
            kop(ix1,iop0)%fs(ix2)=1.d0
          enddo
        end if
      enddo

      deallocate(msx,nsx,ksx,iex)

      return
      end
