      subroutine matrix_adjust2_s(uvi,ib,b,nm)
      use communication_s,only : get_loop_start,
     &                           get_loop_end
      use mod_dmrg
#ifdef EigenExa
      use eigen_libs
#endif
      implicit none
      include 'mpif.h'
      integer :: ib,nm,i,i_1,i_2,i_3,j_2,j_3,ip1,ip2
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) :: 
#endif
     &  uvi(ircnt2(myid_(2)+1,ib),ircnt1(myid_(1)+1,ib)),b(1:nm,*)
#ifdef cmplx_v
      complex(8),allocatable :: 
#else
      real(8),allocatable :: 
#endif
     &  uv0(:,:)

      do ip1=1,np_(1)
        do ip2=1,np_(2)
          allocate(uv0(idisp2(ip2,ib)+1:
     &                 idisp2(ip2,ib)+ircnt2(ip2,ib),
     &                 idisp1(ip1,ib)+1:
     &                 idisp1(ip1,ib)+ircnt1(ip1,ib)))
!$OMP PARALLEL WORKSHARE
          uv0=zero
!$OMP END PARALLEL WORKSHARE

          i_2=get_loop_start(idisp1(ip1,ib)+1,size_of_row,my_row)
          i_3=get_loop_end(idisp1(ip1,ib)+ircnt1(ip1,ib),size_of_row,
     &                     my_row)
          j_2=get_loop_start(idisp2(ip2,ib)+1,size_of_col,my_col)
          j_3=get_loop_end(idisp2(ip2,ib)+ircnt2(ip2,ib),size_of_col,
     &                     my_col)
          do i_1=i_2,i_3
            i=(i_1-1)*size_of_row+my_row
            call XCOPY(j_3-j_2+1,b(j_2,i_1),1,
     &                 uv0((j_2-1)*size_of_col+my_col,i),size_of_col)
          enddo

          call mpi_reduce(uv0,uvi,ircnt2(ip2,ib)*ircnt1(ip1,ib),
     &                    mpi_kv,mpi_sum,(ip1-1)*np_(2)+(ip2-1),
     &                    newcomm_mx,ierr)
          deallocate(uv0)
        enddo
      enddo

      return
      end
