      subroutine mpi_mx(v0)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ib,i,k,ih
      type(avec) :: v0(nbk)
      type(bvec) :: tp

      ih=1

      if(np_mx.eq.1) return

      do ib=isbk0,iebk0
        do i=1,nfrx(1)
          do k=1,nfrx(2)
            if(bk(ib,1,ih)%sizex(i)*bk(ib,2,ih)%sizex(k).eq.0) cycle

            if(.not.allocated(v0(ib)%ap(ad(i,k))%b)) then
              allocate(v0(ib)%ap(ad(i,k))
     &          %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &             bk(ib,2,ih)%sizex(k)))
!$OMP PARALLEL WORKSHARE
              v0(ib)%ap(ad(i,k))%b=zero
!$OMP END PARALLEL WORKSHARE
            end if

            allocate(tp%b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                       bk(ib,2,ih)%sizex(k)))

            call mpi_allreduce(v0(ib)%ap(ad(i,k))%b,tp%b,
     &               bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%sizex(k),
     &               mpi_kv,mpi_sum,newcomm_ev,ierr)

            deallocate(v0(ib)%ap(ad(i,k))%b)

            allocate(v0(ib)%ap(ad(i,k))
     &               %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                  bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))

            if(bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%isz(k).gt.0) then
              call XCOPY(bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%isz(k),
     &                  tp%b(bk(ib,1,ih)%ivs(i),bk(ib,2,ih)%ivs(k)),1,
     &                  v0(ib)%ap(ad(i,k))%b,1)
            end if

            deallocate(tp%b)
          enddo
        enddo
      enddo

      return
      end
