      subroutine mpi_mxint(v0,v1)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ib,i,k,ip,ih
      type(avec) :: v0(nbk),v1(isbk0:iebk0)
      type(bvec) :: tp,sp

      ih=1

      if(np_mx.eq.1) then
        if(np_int.eq.1) then
          do ib=isbk0,iebk0
            do i=1,nfrx(1)
              do k=1,nfrx(2)
                if(bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%isz(k).ne.0) then
                  call XCOPY(bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%isz(k),
     &                       vx(ib)%ap(ad(i,k))%b,1,
     &                       v1(ib)%ap(ad(i,k))%b,1)
                end if
              enddo
            enddo
          enddo
        else
          do ib=isbk0,iebk0
            do i=1,nfrx(1)
              do k=1,nfrx(2)
                if(bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%isz(k).ne.0) then
                  if(.not.allocated(vx(ib)%ap(ad(i,k))%b)) then
                    allocate(vx(ib)%ap(ad(i,k))
     &                       %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                          bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))
!$OMP PARALLEL WORKSHARE
                    vx(ib)%ap(ad(i,k))%b=zero
!$OMP END PARALLEL WORKSHARE
                  end if
                  call mpi_allreduce(vx(ib)%ap(ad(i,k))%b,
     &                       v1(ib)%ap(ad(i,k))%b,
     &                       bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%isz(k),
     &                       mpi_kv,mpi_sum,newcomm_int,ierr)
                end if
              enddo
            enddo
          enddo
        end if
      else
        do ib=isbk0,iebk0
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              if(bk(ib,1,ih)%sizex(i)*bk(ib,2,ih)%sizex(k).eq.0) cycle

              if(.not.allocated(v0(ib)%ap(ad(i,k))%b)) then
                allocate(v0(ib)%ap(ad(i,k))
     &            %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &               bk(ib,2,ih)%sizex(k)))
!$OMP PARALLEL WORKSHARE
                v0(ib)%ap(ad(i,k))%b=zero
!$OMP END PARALLEL WORKSHARE
              end if

              allocate(tp%b(bk(ib,1,ih)%isz(i),bk(ib,2,ih)%isz(k)))

              do ip=1,np_env
                if(bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%ircntv(ip,k).le.0) 
     &            cycle
                if(myid_env.eq.ip-1) then
                  call mpi_reduce(v0(ib)%ap(ad(i,k))
     &                            %b(:,bk(ib,2,ih)%idispv(ip,k)+1),tp%b,
     &                            bk(ib,1,ih)%isz(i)
     &                              *bk(ib,2,ih)%ircntv(ip,k),
     &                            mpi_kv,mpi_sum,ip-1,newcomm_ev,ierr)
                else
                  allocate(sp%b(bk(ib,1,ih)%isz(i),
     &                          bk(ib,2,ih)%ircntv(ip,k)))
                  call mpi_reduce(v0(ib)%ap(ad(i,k))
     &                            %b(:,bk(ib,2,ih)%idispv(ip,k)+1),tp%b,
     &                            bk(ib,1,ih)%isz(i)
     &                              *bk(ib,2,ih)%ircntv(ip,k),
     &                            mpi_kv,mpi_sum,ip-1,newcomm_ev,ierr)
                  deallocate(sp%b)
                end if
              enddo

              call mpi_allreduce(tp%b,v1(ib)%ap(ad(i,k))%b,
     &                           bk(ib,1,ih)%isz(i)*bk(ib,2,ih)%isz(k),
     &                           mpi_kv,mpi_sum,newcomm_int,ierr)
              deallocate(tp%b)
            enddo
          enddo
        enddo
      end if

      return
      end
