      subroutine mpi_uv(ise,nx,ib,jb)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ise,nx,ib,jb,iac,i,lsta,lend,lsize

      if(np_bk.eq.1) return

      allocate(mpist(MPI_STATUS_SIZE))
      do i=1,nfr
        iac=0; lsize=0
        if(block(ise,nx,mh)%kid(ib).eq.myid_bk) then
          if(.not.allocated(block(ise,nx,mh)%b(jb)%s(i)%uv)) then
            iac=1
            call para_range(1,block(ise,nx,mh)%sizex(jb,i),
     &                      np_env,myid_env,lsta,lend)
            allocate(block(ise,nx,mh)%b(jb)%s(i)
     &               %uv(lsta:lend,
     &                   block(ise,nx,mh)%ista0(jb,1):
     &                   block(ise,nx,mh)%iend0(jb,1)))

            mem_uv=mem_uv+8*size(block(ise,nx,mh)%b(jb)%s(i)%uv)
          end if
        end if

        call mpi_bcast(iac,1,mpi_integer,block(ise,nx,mh)%kid(ib),
     &                 newcomm_bk,ierr)

        if(iac.ne.0) then
          if(myid_bk.eq.block(ise,nx,mh)%kid(jb)) then
            call para_ranges(1,block(ise,nx,mh)%sizex(jb,i),
     &                       np_env,myid_env,lsta,lend,lsize)

            call mpi_send(block(ise,nx,mh)%b(jb)%s(i)
     &                    %uv(:,block(ise,nx,mh)%ista0(jb,1):
     &                          block(ise,nx,mh)%iend0(jb,1)),
     &                    lsize
     &                   *block(ise,nx,mh)%isize0(jb,1),
     &                    mpi_kv,
     &                    block(ise,nx,mh)%kid(ib),
     &                    ib*1000+jb,
     &                    newcomm_bk,ierr)

          elseif(myid_bk.eq.block(ise,nx,mh)%kid(ib)) then

            call mpi_recv(block(ise,nx,mh)%b(jb)%s(i)
     &                    %uv(:,block(ise,nx,mh)%ista0(jb,1):
     &                          block(ise,nx,mh)%iend0(jb,1)),
     &                    lsize
     &                   *block(ise,nx,mh)%isize0(jb,1),
     &                    mpi_kv,
     &                    block(ise,nx,mh)%kid(jb),
     &                    ib*1000+jb,
     &                    newcomm_bk,mpist,ierr)

          end if
        end if
      enddo
      deallocate(mpist)

      return
      end
