      subroutine noize_el(x,n)
      use mod_dmrg
      implicit none
      integer :: n
#ifdef cmplx_v
      real(8) :: twpi
      complex(8) ::
#else
      real(8) ::
#endif
     &  x(n)
      real(8),allocatable :: y(:)

      allocate(y(n))

      call random_number(y(1:n))

#ifdef cmplx_v
      twpi=8.d0*atan(1.d0)
!$OMP PARALLEL WORKSHARE
      x(1:n)=x(1:n)+(w_nz/(1.d0+w_nz))
     &  *(cmplx(cos(twpi*y(1:n)),sin(twpi*y(1:n)),kind=8))
!$OMP END PARALLEL WORKSHARE
#else
!$OMP PARALLEL WORKSHARE
      x(1:n)=x(1:n)+(w_nz/(1.d0+w_nz))*(y(1:n)-0.5d0)
!$OMP END PARALLEL WORKSHARE
#endif

      deallocate(y)

      return
      end
