      subroutine para_int(id_h,iop)
      use mod_dmrg
      implicit none
      integer :: id_h,iop,iop1,iop0,it,myct
      real(8) :: ctn,ctl,ctj
      real(8),allocatable :: ct(:)

      if(np_int.ge.iop) then
        call para_range(1,iop,np_int,myid_int,ista_int,iend_int)
        return
      end if

      allocate(ct(iop*2))

      iop0=1   !SYSTEM AND ENVIRONMENT BLOCKS:0
      ct(iop0)=4.d0

      do iop1=1,nh2
        if(hamil(iop1)%ihs(2).lt.iad(1).or.
     &     hamil(iop1)%ihs(1).gt.iad(2)) cycle

        if(hamil(iop1)%ihs(1).lt.iad(1).and.
     &     hamil(iop1)%ihs(2).eq.iad(1).and.
     &     nas.ne.0.and.(id_h.eq.0.or.id_h.eq.1)) then  !SYS.BLOCK--SYS.ADDED:1
          if(ck2(iop1,1)%num(1)*ck2(iop1,1)%num(2).eq.0) cycle
          do it=1,nit
            if(abs(ht(it)*hamil(iop1)%vh(ihcf(it))).lt.dlim_int) cycle
            iop0=iop0+1
            ct(iop0)=dble(4*(ihm(it)+1))
          enddo

        elseif(hamil(iop1)%ihs(1).eq.iad(2).and.
     &         hamil(iop1)%ihs(2).gt.iad(2).and.
     &         nae.ne.0.and.(id_h.eq.0.or.id_h.eq.2)) then !ENV.ADDED--ENV.BLOCK:2
          if(ck2(iop1,2)%num(1)*ck2(iop1,2)%num(2).eq.0) cycle
          do it=1,nit
            if(abs(ht(it)*hamil(iop1)%vh(ihcf(it))).lt.dlim_int) cycle
            iop0=iop0+1
            ct(iop0)=dble(4*(ihm(it)+1))
          enddo

        elseif(hamil(iop1)%ihs(1).lt.iad(1).and.
     &         hamil(iop1)%ihs(2).eq.iad(2).and.
     &         nae.ne.0.and.id_h.eq.0) then  !SYS.BLOCK--ENV.ADDED:3
          if(ck2(iop1,1)%num(1)*ck2(iop1,1)%num(2).eq.0) cycle
          do it=1,nit
            if(abs(ht(it)*hamil(iop1)%vh(ihcf(it))).lt.dlim_int) cycle
            iop0=iop0+1
            ct(iop0)=dble(8*(ihm(it)+1))
          enddo

        elseif(hamil(iop1)%ihs(1).eq.iad(1).and.
     &         hamil(iop1)%ihs(2).gt.iad(2).and.
     &         nas.ne.0.and.id_h.eq.0) then  !SYS.ADDED--ENV.BLOCK:4
          if(ck2(iop1,2)%num(1)*ck2(iop1,2)%num(2).eq.0) cycle
          do it=1,nit
            if(abs(ht(it)*hamil(iop1)%vh(ihcf(it))).lt.dlim_int) cycle
            iop0=iop0+1
            ct(iop0)=dble(8*(ihm(it)+1))
          enddo

        elseif(hamil(iop1)%ihs(1).lt.iad(1).and.
     &         hamil(iop1)%ihs(2).gt.iad(2).and.id_h.eq.0) then !SYS.BLOCK--ENV.BLOCK:5
          if(ck2(iop1,0)%num(1)*ck2(iop1,0)%num(2).eq.0) cycle
          do it=1,nit
            if(abs(ht(it)*hamil(iop1)%vh(ihcf(it))).lt.dlim_int) cycle
            iop0=iop0+1
            ct(iop0)=dble(24*(ihm(it)+1))
          enddo

        elseif(hamil(iop1)%ihs(1).eq.iad(1).and.
     &         hamil(iop1)%ihs(2).eq.iad(2).and.
     &         nas*nae.ne.0.and.id_h.eq.0) then !SYS.ADDED-ENV.ADDED:6
          do it=1,nit
            if(abs(ht(it)*hamil(iop1)%vh(ihcf(it))).lt.dlim_int) cycle
            iop0=iop0+1
            ct(iop0)=1.d0
          enddo

        elseif(hamil(iop1)%ihs(1).eq.iad(1).and.
     &         hamil(iop1)%ihs(2).eq.iad(1).and.
     &         nas.ne.0.and.id_h.eq.0) then !SYSTEM ADDED:7
          iop0=iop0+1
          ct(iop0)=1.d0

        elseif(hamil(iop1)%ihs(1).eq.iad(2).and.
     &         hamil(iop1)%ihs(2).eq.iad(2).and.
     &         nae.ne.0.and.id_h.eq.0) then !ENVIRONMENT ADDED:8
          iop0=iop0+1
          ct(iop0)=1.d0
    
        end if
      enddo

      do iop1=nh2+1,nh2+nh4
        if(kd4(iop1).eq.0) cycle
        if(ck4(iop1,0)%num(0).eq.0) cycle

        if(id_spin.eq.0) then
          if(kd4(iop1).eq.1) then !(12)-(34) Coulomb interactions
            if(hamil(iop1)%ihs(1).eq.iad(1).and.
     &         hamil(iop1)%ihs(3).eq.iad(1).and.
     &         nas.ne.0) then !system added
              iop0=iop0+1
              ct(iop0)=2.d0
            elseif(hamil(iop1)%ihs(1).eq.iad(2).and.
     &             hamil(iop1)%ihs(3).eq.iad(2).and.
     &             nae.ne.0) then !environment added
              iop0=iop0+1
              ct(iop0)=2.d0
            elseif((hamil(iop1)%ihs(1).eq.iad(1).and.nas.ne.0).and.
     &             (hamil(iop1)%ihs(3).eq.iad(2).and.nae.ne.0)) then !system and environment added
              iop0=iop0+1
              ct(iop0)=2.d0
            elseif(hamil(iop1)%ihs(1).lt.iad(1).and.
     &             hamil(iop1)%ihs(3).eq.iad(1).and.
     &             nas.ne.0) then !system block and added
              if(ckc(iop1,1)%num(1)*ckc(iop1,1)%num(2).eq.0) cycle
              iop0=iop0+1
              ct(iop0)=2.d0
            elseif(hamil(iop1)%ihs(1).lt.iad(1).and.
     &             hamil(iop1)%ihs(3).eq.iad(2).and.
     &             nae.ne.0) then !system block and environment added
              if(ckc(iop1,1)%num(1)*ckc(iop1,1)%num(2).eq.0) cycle
              iop0=iop0+1
              ct(iop0)=2.d0
            elseif((hamil(iop1)%ihs(1).eq.iad(2).and.nae.ne.0).and.
     &             hamil(iop1)%ihs(3).gt.iad(2)) then !environment added and block
              if(ckc(iop1,2)%num(1)*ckc(iop1,2)%num(2).eq.0) cycle
              iop0=iop0+1
              ct(iop0)=2.d0
            elseif((hamil(iop1)%ihs(1).eq.iad(1).and.nas.ne.0).and.
     &             hamil(iop1)%ihs(3).gt.iad(2)) then !system added and environment block
              if(ckc(iop1,2)%num(1)*ckc(iop1,2)%num(2).eq.0) cycle
              iop0=iop0+1
              ct(iop0)=2.d0
            elseif(hamil(iop1)%ihs(1).lt.iad(1).and.
     &             hamil(iop1)%ihs(3).gt.iad(2).and.
     &             nae.ne.0) then !system block and environment block
              if(ckc(iop1,0)%num(1)*ckc(iop1,0)%num(2).eq.0) cycle
              iop0=iop0+1
              ct(iop0)=2.d0
            end if
          elseif(kd4(iop1).eq.2) then !(123)-(4),(3)-(124),(134)--(2),(1)--(234)
            do it=1,2
              iop0=iop0+1
              ct(iop0)=4.d0
            enddo
          elseif(kd4(iop1).eq.3) then !(13)--(24)
            do it=1,4
              iop0=iop0+1
              ct(iop0)=4.d0
            enddo
          elseif(kd4(iop1).eq.4) then !(12)--(3)--(4),(1)--(2)--(34)
            if(ck4(iop1,0)%ntyp.eq.1) then
              do it=1,2
                iop0=iop0+1
                ct(iop0)=4.d0
              enddo
            else
              do it=1,4
                iop0=iop0+1
                ct(iop0)=4.d0
              enddo
            end if
          elseif(kd4(iop1).eq.5) then
            if(ck4(iop1,0)%ntyp.eq.1) then
              do it=1,2
                iop0=iop0+1
                ct(iop0)=4.d0
              enddo
            else
              do it=1,6
                iop0=iop0+1
                ct(iop0)=4.d0
              enddo
            end if
          elseif(kd4(iop1).eq.6) then
            if(ck4(iop1,0)%ntyp.eq.1) then
              do it=1,2
                iop0=iop0+1
                ct(iop0)=4.d0
              enddo
            else
              do it=1,6
                iop0=iop0+1
                ct(iop0)=4.d0
              enddo
            end if
          elseif(kd4(iop1).eq.7) then
            if(ck4(iop1,0)%ntyp.ne.0) then
              do it=1,2
                iop0=iop0+1
                ct(iop0)=4.d0
              enddo
            else
              do it=1,8
                iop0=iop0+1
                ct(iop0)=4.d0
              enddo
            end if
          end if

        else !4-SPIN
          if(kd4(iop1).eq.3) then
            do it=1,5
              iop0=iop0+1
              ct(iop0)=4.d0
            enddo
          else
            do it=1,15
              iop0=iop0+1
              ct(iop0)=4.d0
            enddo
          end if
        end if
      enddo

      ctn=0.d0; ista_int=iop0+1; iend_int=iop0
!$OMP PARALLEL DO REDUCTION(+:ctn)
      do iop1=1,iop0
        ctn=ctn+ct(iop1)
      enddo

      ctl=ctn/dble(np_int)
      myct=0
      if(myid_int.eq.0) then
        ista_int=1
      end if
      ctj=ct(1)
      do iop1=2,iop0-1
        ctj=ctj+ct(iop1)
        if(ctj.ge.ctl) then
          if(myid_int.eq.myct) then
            iend_int=iop1-1
          end if
          myct=myct+1
          if(myid_int.eq.myct) then
            ista_int=iop1
          end if
          ctj=ct(iop1)
        end if
      enddo

      if(myid_int+1.eq.np_int) then
        iend_int=iop
      end if

c      if(myid.eq.0) write(6,*) ctn
c      write(6,*) myid,ista_int,iend_int,iop,myct

      deallocate(ct)

      return
      end
