      subroutine phys_ipara(iv,ip,tp,mp,nss,mx,iout)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iv,ip,mp,mx,kp,jp,ix,iy,nss(mx,*),ib,i,k,ih,iout,iso1
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: res(:)
      type(inop) :: tp(mp)
      type(avec),allocatable :: va(:)

      ih=1

      allocate(va(isbk0:iebk0))
      do ib=isbk0,iebk0
        allocate(va(ib)%ap(nfrx(1)*nfrx(2)))
        do k=1,nfrx(2)
          do i=1,nfrx(1)
            if(bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1.gt.0.and.
     &         bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1.gt.0) then

              allocate(va(ib)%ap(ad(i,k))
     &                 %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                    bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))

              if(myid_int.eq.kid1(ib)) then
                va(ib)%ap(ad(i,k))%b=v(ib,iv)%ap(ad(i,k))%b
              end if

              call mpi_bcast(va(ib)%ap(ad(i,k))%b,
     &                       (bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                      *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                        mpi_kv,kid1(ib),newcomm_int,ierr)

            end if
          enddo
        enddo
      enddo

      allocate(res(ip))
      do jp=1,ip
        if(mod(jp-1,np_int).eq.myid_int) then
          kp=0
          do ix=1,mp
            tp(ix)%ni(1:tp(ix)%mi)=nss(kp+1:kp+tp(ix)%mi,jp)
            kp=kp+tp(ix)%mi
          enddo
          call phys_cal(va,tp,mp,res(jp))
        end if
      enddo

      do jp=1,ip
        call mpi_bcast(res(jp),1,mpi_kv,mod(jp-1,np_int),newcomm_int,
     &                 ierr)
        if(allocated(rphys_tp)) then
          icount=icount+1
          rphys_tp(icount)=res(jp)
        else
          if(myid_dmrg.eq.key_rank) then
            iso1=iso
            do iy=1,1+iout
              do ix=1,sum(tp(1:mp)%mi)
                write(iso1,'(1x,I5,1x)',advance='no') nss(ix,jp)
              enddo
#ifdef cmplx_v
              write(iso1,'(f15.10,1x,f15.10)') 
     &            real(res(jp)),aimag(res(jp))
              if(id_tdmrg.eq.1.and.iy.eq.1) then
                do ix=1,sum(tp(1:mp)%mi)
                  write(50,'(1x,I5,1x)',advance='no') nss(ix,jp)
                enddo
                write(50,'(f15.10,1x,f15.10)') 
     &              real(res(jp)),aimag(res(jp))
              end if
#else
              write(iso1,'(f15.10)') res(jp)
#endif
              iso1=51
            enddo
          end if
        end if
      enddo
      deallocate(va,res)
      ip=0

      return
      end
