      subroutine read_mag(para)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: i
      real(8) :: fmagx,fmagy,fmagz,ftmp
      character(256) :: para

      if(.not.allocated(fmag)) then
        allocate(fmag(3,nsite))
!$OMP PARALLEL WORKSHARE
        fmag=0.d0
!$OMP END PARALLEL WORKSHARE
      end if

      if(index(para,'x').ne.0.or.index(para,'X').ne.0) then !x-direction
        i=index(para,'=')
        read(para(i+1:),*) ftmp
!$OMP PARALLEL WORKSHARE
        fmag(1,:)=ftmp
!$OMP END PARALLEL WORKSHARE

      elseif(index(para,'y').ne.0.or.index(para,'Y').ne.0) then !y-direction
        i=index(para,'=')
        read(para(i+1:),*) ftmp
!$OMP PARALLEL WORKSHARE
        fmag(2,:)=ftmp
!$OMP END PARALLEL WORKSHARE

      elseif(index(para,'z').ne.0.or.index(para,'Z').ne.0) then !z-direction
        i=index(para,'=')
        read(para(i+1:),*) ftmp
!$OMP PARALLEL WORKSHARE
        fmag(3,:)=ftmp
!$OMP END PARALLEL WORKSHARE

      else !each site
        read(para,*) i,fmagx,fmagy,fmagz
        fmag(1,i)=fmag(1,i)+fmagx
        fmag(2,i)=fmag(2,i)+fmagy
        fmag(3,i)=fmag(3,i)+fmagz
      end if

      return
      end
