      subroutine trabset_op(iop,vop,nov,kb,ise,ib,jb,bp,nx,ia,b,fsign,
     &                      id)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iop(nfr),nov(2),kb(*),ise,ib,jb,nx,i1,i2,ix,ia,ip,
     &           ista,iend,isize,jsta,jend,jsize,ksta,kend,ksize,id,
     &           lsta,lend,lsize,ix0,ix1,ix2,
     &           kmin,kmax,id_fop
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  vop(nfr),b,fs
      real(8) :: fsign
#ifdef cmplx_v
      complex(8),allocatable ::
#else
      real(8),allocatable ::
#endif
     &  ht0(:,:),ht1(:,:),ht2(:,:),uvx(:,:)
      integer,allocatable :: ircntx(:),idispx(:),ircnty(:),idispy(:)
      type(bop) :: bp

      id_fop=1
      if(.not.allocated(np(mod(nx-1,2)+1)%bp)) then
        ista=block(ise,nx,mh)%ista0(ib,1)
        iend=min(block(ise,nx,mh)%iend0(ib,1),block(ise,nx,mh)%size(ib))
        isize=max(iend-ista+1,0)

        call para_range(1,block(ise,nx,mh)%size(jb),
     &                  np_env,myid_env,ksta,kend)
        ksize=max(kend-ksta+1,0)

        allocate(ircnt(np_sys),idisp(np_sys))
        call pre_algv(block(ise,nx,mh)%isize0(jb,1),np_sys,
     &                newcomm_sys,ircnt,idisp)

        allocate(ht0(block(ise,nx,mh)%size(jb),isize))
#ifdef tp_safe
!$OMP PARALLEL WORKSHARE
        ht0=zero
!$OMP END PARALLEL WORKSHARE
#endif

        ix=0
        do i1=1,nfr
          i2=iop(i1)
          if(block(ise,nx,mh)%size(jb)*block(ise,nx,mh)%size(ib)
     &      *block(ise,nx,mh)%sizex(ib,i1)*i2.ne.0) then

            call para_range(1,block(ise,nx,mh)%sizex(jb,i2),
     &                      np_env,myid_env,lsta,lend)
            lsize=max(lend-lsta+1,0)

            allocate(uvx(lsize,block(ise,nx,mh)%size0(jb)))
            call gr2d(block(ise,nx,mh)%b(jb)%s(i2)%uv,
     &                lsize*ircnt(myid_sys+1),uvx,np_sys,newcomm_sys)

            if(block(ise,nx,mh)%size(jb)*isize*lsize.ne.0)then
              call XGEMM(chmm(2),chmm(1),
     &             block(ise,nx,mh)%size(jb),isize,lsize,
     &             b*vop(i1),
     &             uvx,lsize,
     &             block(ise,nx,mh)%b(ib)%s(i1)%uv(:,ista:iend),
     &             lsize,
     &             dble(ix)*one,
     &             ht0,
     &             block(ise,nx,mh)%size(jb))
               ix=1
            end if
            deallocate(uvx)
          end if
        enddo

      elseif(block(ise,nx,mh)%size(ib)
     &        *block(ise,nx,mh)%size(jb).ne.0) then
        ista=block(ise,nx,mh)%ista0(ib,1)
        iend=min(block(ise,nx,mh)%iend0(ib,1),block(ise,nx,mh)%size(ib))
        isize=max(iend-ista+1,0)

        jsta=block(ise,nx,mh)%ista0(jb,1)
        jend=min(block(ise,nx,mh)%iend0(jb,1),block(ise,nx,mh)%size(jb))
        jsize=max(jend-jsta+1,0)

        allocate(ircnt(np_sys),idisp(np_sys))
        call pre_algv(jsize,np_sys,newcomm_sys,ircnt,idisp)

        allocate(ht0(block(ise,nx,mh)%size(jb),isize))
#ifdef tp_safe
!$OMP PARALLEL WORKSHARE
        ht0=zero
!$OMP END PARALLEL WORKSHARE
#endif
        ix=0

        do i1=1,nfr
          i2=iop(i1)
          if(i2.eq.0) cycle
          if(block(ise,nx,mh)%sizex(ib,i1)
     &      *block(ise,nx,mh)%sizex(jb,i2).ne.0) then

            if(iftp.eq.1) then
              fs=fsign**(abs(nov(1))*iud(i1,1)
     &                  +abs(nov(2))*iud(i1,2))*vop(i1)
            elseif(iftp.eq.2) then
              fs=fsign**((abs(nov(1))+abs(nov(2)))
     &                  *(iud(i1,1)+iud(i1,2)))*vop(i1)
            else
              fs=vop(i1)
            end if

            call para_range(1,block(ise,nx,mh)%sizex(ib,i1),
     &                      np_env,myid_env,ksta,kend)
            ksize=max(kend-ksta+1,0)

            allocate(ht1(jsta:jend,ksta:kend))

            call para_range(1,block(ise,nx,mh)%sizex(jb,i2),
     &                      np_env,myid_env,lsta,lend)
            lsize=max(lend-lsta+1,0)

            allocate(ircntx(np_env),idispx(np_env))
            call pre_algv(lsize,np_env,newcomm_env,ircntx,idispx)

            if(np_env.eq.1) then
              if(jsize*ksize*block(ise,nx,mh)%sizex(jb,i2).ne.0) then
                call XGEMM(chmm(2),chmm(1),
     &                     jsize,
     &                     ksize,
     &                     block(ise,nx,mh)%sizex(jb,i2),
     &                     fs,
     &                     block(ise,nx,mh)%b(jb)%s(i2)%uv,
     &                     block(ise,nx,mh)%sizex(jb,i2),
     &                     np(mod(nx-1,2)+1)%bp(kb(i1),1)%op,
     &                     block(ise,nx,mh)%sizex(jb,i2),
     &                     zero,
     &                     ht1,
     &                     jsize)
              end if
            else
              allocate(uvx(block(ise,nx,mh)%sizex(jb,i2),jsize))
              call gc2d(block(ise,nx,mh)%b(jb)%s(i2)%uv,
     &                  lsize,jsize,uvx,block(ise,nx,mh)%sizex(jb,i2),
     &                  np_env,newcomm_env)
              if(jsize*ksize*block(ise,nx,mh)%sizex(jb,i2).ne.0) then
                ix0=0
                do ip=1,np_env
                  if(ircntx(ip).le.0) cycle
                  call XGEMM(chmm(2),chmm(1), !chmm(1)='N',chmm(2)='T'
     &                       jsize,
     &                       ksize,
     &                       ircntx(ip),
     &                       fs,
     &                       uvx(idispx(ip)+1,1),
     &                       block(ise,nx,mh)%sizex(jb,i2),
     &                       np(mod(nx-1,2)+1)%bp(kb(i1),ip)
     &                           %op(idispx(ip)+1,ksta),
     &                       size(np(mod(nx-1,2)+1)%bp(kb(i1),ip)
     &                           %op(:,ksta)),
     &                       dble(ix0)*one,
     &                       ht1,
     &                       jsize)
                  ix0=1
                enddo
              end if
              deallocate(uvx)
            end if

            deallocate(ircntx,idispx)

            allocate(ht2(block(ise,nx,mh)%size(jb),ksize))
            call gc2d(ht1,ircnt(myid_sys+1),ksize,ht2,
     &                block(ise,nx,mh)%size(jb),np_sys,
     &                newcomm_sys)

            deallocate(ht1)

            if(block(ise,nx,mh)%size(jb).ne.0.and.
     &         isize*ksize.ne.0) then
              call XGEMM(chmm(1),chmm(1),
     &             block(ise,nx,mh)%size(jb),
     &             isize,
     &             ksize,
     &             b,
     &             ht2,
     &             block(ise,nx,mh)%size(jb),
     &             block(ise,nx,mh)%b(ib)%s(i1)%uv,
     &             ksize,
     &             dble(ix)*one,
     &             ht0,
     &             block(ise,nx,mh)%size(jb))
              ix=1
            end if
            deallocate(ht2)
          end if
        enddo
      else
        return
      end if

      if(ix.eq.0) then
!$OMP PARALLEL WORKSHARE
        ht0=zero
!$OMP END PARALLEL WORKSHARE
      end if

      if(np_mx.eq.1) then
        if(id.eq.1) then
          if(ia.eq.0) then
            call XCOPY(block(ise,nx,mh)%size(jb)
     &                 *block(ise,nx,mh)%size(ib),
     &                 ht0,1,bp%bt(ib)%op,1)
          else
            call XAXPY(block(ise,nx,mh)%size(jb)
     &                 *block(ise,nx,mh)%size(ib),
     &                 one,ht0,1,bp%bt(ib)%op,1)
          end if
        elseif(id.eq.0) then
          if(ia.eq.0) then
            call XCOPY(block(ise,nx,mh)%size(jb)
     &                 *block(ise,nx,mh)%size(ib),
     &                 ht0,1,np(mod(nx,2)+1)%bp(ib,1)%op,1)
          else
            call XAXPY(block(ise,nx,mh)%size(jb)
     &                 *block(ise,nx,mh)%size(ib),
     &                 one,ht0,1,np(mod(nx,2)+1)%bp(ib,1)%op,1)
          end if
        end if
      else
        allocate(ht1(block(ise,nx,mh)%size(jb),isize))
        call mpi_allreduce(ht0,ht1,block(ise,nx,mh)%size(jb)*isize,
     &                     mpi_kv,mpi_sum,newcomm_env,ierr)
        deallocate(ht0)

        if(id.eq.1) then
          if(ia.eq.0) then
            call gr2d(ht1,block(ise,nx,mh)%size(jb)*isize,bp%bt(ib)%op,
     &                np_sys,newcomm_sys)
          else
            if(block(ise,nx,mh)%size(jb)*isize.gt.0) then
              call XAXPY(block(ise,nx,mh)%size(jb)*isize,
     &                   one,bp%bt(ib)%op(:,ista:iend),1,ht1,1)
            end if
            call gr2d(ht1,block(ise,nx,mh)%size(jb)*isize,bp%bt(ib)%op,
     &                np_sys,newcomm_sys)
          end if
          deallocate(ht1)
        elseif(id.eq.0) then
          call para_range(1,block(ise,nx,mh)%size(ib),np_env,myid_env,
     &                    ksta,kend)
          kmin=max(ista,block(ise,nx,mh)%ista0(ib,1),ksta)
     &         -block(ise,nx,mh)%ista0(ib,1)+1
          kmax=min(isize+block(ise,nx,mh)%ista0(ib,1)-1,iend,kend)
     &         -block(ise,nx,mh)%ista0(ib,1)+1
          ix=max(kmax-kmin+1,0)
          allocate(ircnty(np_sys),idispy(np_sys))

!!!          if(id_fop.eq.1.and.1==0) then
!!!            call pre_algv(ix*block(ise,nx,mh)%size(jb),np_sys,
!!!     &                    newcomm_sys,ircnty,idispy)
!!!            call mpi_allgatherv(ht1(:,min(kmin,block(ise,nx,mh)
!!!     &                          %size(jb)):kmax),ircnty(myid_sys+1),
!!!     &                          mpi_kv,
!!!     &                          np(mod(nx,2)+1)%bp(ib,1)%op,
!!!     &                          ircnty,idispy,mpi_kv,newcomm_sys,
!!!     &                          ierr)
!!!          else
            allocate(ircntx(np_env),idispx(np_env))
            call pre_algv2(1,block(ise,nx,mh)%size(jb),np_env,
     &                     ircntx,idispx)
            do ip=1,np_env
              allocate(ht0(idispx(ip)+1:idispx(ip)+ircntx(ip),
     &                     kmin:kmax))

!$OMP PARALLEL DO PRIVATE(ix1,ix2)
              do ix0=1,(kmax-kmin+1)*ircntx(ip)
                ix2=(ix0-1)/ircntx(ip)+kmin
                ix1=mod(ix0-1,ircntx(ip))+idispx(ip)+1
                ht0(ix1,ix2)=ht1(ix1,ix2)
              enddo
              call pre_algv(ix*ircntx(ip),np_sys,newcomm_sys,ircnty,
     &                      idispy)

              call mpi_allgatherv(ht0,ircntx(ip)*ix,mpi_kv,
     &                            np(mod(nx,2)+1)%bp(ib,ip)%op,ircnty,
     &                            idispy,mpi_kv,newcomm_sys,ierr)

              deallocate(ht0)
            enddo
            deallocate(ircntx,idispx)
!!!          end if

          deallocate(ht1,ircnty,idispy)
        end if
      end if
      deallocate(ircnt,idisp)

      return
      end
