      subroutine trans_set_bk(hin,ise,jse,ib,i1,nx,mhx,lsta,lend)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ise,nx,ib,ix1,ix2,i1,jsta,jend,ista,iend,
     &           ksta,kend,isize,jsize,ksize,mhx,jse,lsta(*),lend(*)
#ifdef cmplx_v
      complex(8) :: hin(*)
      complex(8),
#else
      real(8) :: hin(*)
      real(8),
#endif
     &  allocatable :: tmp(:,:),tmp0(:,:)

      call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i1),np_vec,
     &                 myid_vec,jsta,jend,jsize)
      call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i1),
     &                 np_(ise),myid_(ise),ista,iend,isize)
      call para_ranges(jsta,jend,np_(jse),myid_(jse),
     &                 ksta,kend,ksize)

      select case(ise)
      case(1)
        allocate(tmp(block(ise,nx,mhx)%sizex(ib,i1),ksta:kend))
        call gc2d(hin,isize,
     &            ksize,tmp,block(ise,nx,mhx)%sizex(ib,i1),
     &            np_sys,newcomm_sys)

        allocate(tmp0(block(ise,nx,mhx)%sizex(ib,i1),jsta:jend))
        call gr2d(tmp,block(ise,nx,mhx)%sizex(ib,i1)*ksize,
     &            tmp0,np_env,newcomm_env)
        deallocate(tmp)

        allocate(tmp(block(ise,nx,mhx)%sizex(ib,i1),
     &               block(ise,nx,mhx)%sizex(ib,i1)))
        call gr2d(tmp0,block(ise,nx,mhx)%sizex(ib,i1)*jsize,
     &            tmp,np_vec,newcomm_vec)

      case(2)
        allocate(tmp(jsta:jend,ista:iend))
        call gc2d(hin,ksize,
     &            isize,tmp,block(ise,nx,mhx)%sizex(ib,i1),
     &            np_sys,newcomm_sys)

        allocate(tmp0(block(ise,nx,mhx)%sizex(ib,i1),ista:iend))
        call gc2d(tmp,jsize,isize,tmp0,
     &            block(ise,nx,mhx)%sizex(ib,i1),np_vec,
     &            newcomm_vec)
        deallocate(tmp)

        allocate(tmp(block(ise,nx,mhx)%sizex(ib,i1),
     &               block(ise,nx,mhx)%sizex(ib,i1)))
        call gr2d(tmp0,block(ise,nx,mhx)%sizex(ib,i1)*isize,
     &            tmp,np_env,newcomm_env)
      end select

!$OMP PARALLEL DO
      do ix1=1,block(ise,nx,mhx)%sizex(ib,i1)
        do ix2=lsta(i1),lend(i1)
          ast(i1,1)%ht(ix2,ix1+block(ise,nx,mhx)%stax(ib,i1)-1)
     &   =ast(i1,1)%ht(ix2,ix1+block(ise,nx,mhx)%stax(ib,i1)-1)
     &    +tmp(ix2,ix1)
        enddo
      enddo

      deallocate(tmp,tmp0)

      return
      end
