      subroutine wf_weight(istrg,ietrg)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: iv,ib,i,k,istrg,ietrg,ih
      real(8) :: wt,wt_tot

      if(.not.allocated(v)) return

      ih=1

      if(allocated(ddmrg)) then   !DDMRG
        if(mdDMRG.ne.0.and.isweep.gt.ddmrg(1)%nsg-1) then
          wt=sqrt(0.5d0)
          do ib=isbk1,iebk1
            do i=1,nfrx(1)
              do k=1,nfrx(2)
                if((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &            *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1).ne.0) then
                  call XSCAL((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                      *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                       wt,v(ib,1)%ap(ad(i,k))%b,1)
                end if
              enddo
            enddo
          enddo

          wt_tot=0.d0
          do iv=2,ntargd
            call ipv(v(isbk1:iebk1,iv),v(isbk1:iebk1,iv),isbk1,iebk1,wt)
            wt_tot=wt_tot+wt
          enddo

          wt=sqrt(0.5d0/wt_tot)
          do iv=2,ntargd
            do ib=isbk1,iebk1
              do i=1,nfrx(1)
                do k=1,nfrx(2)
                  if((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &             *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1).ne.0) then
                    call XSCAL((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                      *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                      wt,v(ib,iv)%ap(ad(i,k))%b,1)
                  end if
                enddo
              enddo
            enddo
          enddo
        end if

      else
        wt=sqrt(1.d0/dble(ietrg-istrg+1))
        do iv=istrg,ietrg
          call normalize(v(:,iv))
          do ib=isbk1,iebk1
            do i=1,nfrx(1)
              do k=1,nfrx(2)
                if((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &           *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1).ne.0) then
                  call XSCAL((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                    *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                     wt,v(ib,iv)%ap(ad(i,k))%b,1)
                end if
              enddo
            enddo
          enddo
        enddo
      end if

      return
      end
