      subroutine diagola(mab,a,b,e,vt,k,jz,ill)
      implicit real(8)(a-h,o-z)
      dimension a(mab),b(mab),vt(mab*mab),e(mab)
      real(8),allocatable :: work(:),b2(:)
      integer,allocatable :: iwork(:)
      character jobz(2)
      data jobz/'N','V'/

c --- initialize
      ill=0
      allocate(b2(k-1))
!$OMP PARALLEL WORKSHARE
      e(1:k)=a(1:k)
      b2(1:k-1)=b(2:k)
!$OMP END PARALLEL WORKSHARE

c --- lapack working array
      if(jz.eq.1) then
        lwork=1
        liwork=1
      else
        lwork=1+3*k+2*k*9+2*k*k
        liwork=3+5*k
      end if
      allocate(work(lwork),iwork(liwork))

      call DSTEVD(jobz(jz),k,e,b2,vt,k,work,lwork,iwork,liwork,ill)
c      call DSTEV(jobz(jz),k,a2,b2,vt2,k,work,ill)
c      if(k.eq.2) then
c        call mpi_finalize(ierr); stop
c      end if
      if(ill.ne.0) then
        write(6,*) 'error at DSTEVD : ill=',ill
      end if

      deallocate(work,iwork,b2)

      return
      end

