      subroutine gr2d(vin,le,vout,np,ncm)
      implicit none
      include 'mpif.h'
      integer :: le,np,ncm,ierr
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  vin(le),vout(*)
      integer,allocatable :: ircnt(:),idisp(:)

      allocate(ircnt(np),idisp(np))

      call pre_algv(le,np,ncm,ircnt,idisp)

#ifdef cmplx_v
      call mpi_allgatherv(vin,le,mpi_double_complex,vout,ircnt,idisp,
     &                    mpi_double_complex,ncm,ierr)
#else
      call mpi_allgatherv(vin,le,MPI_REAL8,vout,ircnt,idisp,MPI_REAL8,
     &                    ncm,ierr)
#endif

      deallocate(ircnt,idisp)

      return
      end

************************************************************************
      subroutine gr2ds(vin,le,vout,np,iroot,ncm)
      implicit none
      include 'mpif.h'
      integer :: le,np,ncm,iroot,ierr
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  vin(le),vout(*)
      integer,allocatable :: ircnt(:),idisp(:)

      allocate(ircnt(np),idisp(np))

      call pre_algv(le,np,ncm,ircnt,idisp)

#ifdef cmplx_v
      call mpi_gatherv(vin,le,mpi_double_complex,vout,ircnt,idisp,
     &                 mpi_double_complex,iroot,ncm,ierr)
#else
      call mpi_gatherv(vin,le,MPI_REAL8,vout,ircnt,idisp,MPI_REAL8,
     &                 iroot,ncm,ierr)
#endif

      deallocate(ircnt,idisp)

      return
      end
