      subroutine hamil_4(id,iop,iop0,lop)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: id,iop,iop0,it,nt,lop(*)

      nt=0
      if(kd4(iop).eq.1) then !(12)-(34) Coulomb interactions
        call hamil_c(id,iop,iop0)
        return
      elseif(kd4(iop).eq.2) then !(123)-(4),(3)-(124),(134)--(2),(1)--(234)
        nt=2
        if(id.eq.2) then
          th(1)%ic(iop0+1:iop0+nt)=1   !0:not take H.C. in matrix_vec
        end if
      elseif(kd4(iop).eq.3) then !(13)--(24)
        nt=4
        if(id.eq.2) then
          do it=1,nt
            th(1)%ic(iop0+it)=it/3
          enddo
        end if
      elseif(kd4(iop).eq.4) then !(12)--(3)--(4),(1)--(2)--(34)
        if(ck4(iop,0)%ntyp.eq.1) then
          nt=2
          if(id.eq.2) then
            th(1)%ic(iop0+1:iop0+nt)=1   !0:not take H.C. in matrix_vec
          end if
        else
          nt=4
          if(id.eq.2) then
            th(1)%ic(iop0+1:iop0+nt)=1   !0:not take H.C. in matrix_vec
          end if
        end if
      elseif(kd4(iop).eq.5) then
        if(ck4(iop,0)%ntyp.eq.1) then
          nt=2
          if(id.eq.2) then
            th(1)%ic(iop0+1:iop0+nt)=1   !0:not take H.C. in matrix_vec
          end if
        else
          nt=6
          if(id.eq.2) then
            th(1)%ic(iop0+1:iop0+nt)=1   !0:not take H.C. in matrix_vec
          end if
        end if
      elseif(kd4(iop).eq.6) then
        if(ck4(iop,0)%ntyp.eq.1) then
          nt=2
          if(id.eq.2) then
            th(1)%ic(iop0+1:iop0+nt)=1   !0:not take H.C. in matrix_vec
          end if
        else
          nt=6
          if(id.eq.2) then
            th(1)%ic(iop0+1:iop0+nt)=1   !0:not take H.C. in matrix_vec
          end if
        end if
      elseif(kd4(iop).eq.7) then
        if(ck4(iop,0)%ntyp.ne.0) then
          nt=2
          if(id.eq.2) then
            th(1)%ic(iop0+1:iop0+nt)=1   !0:not take H.C. in matrix_vec
          end if
        else
          nt=8
          if(id.eq.2) then
            th(1)%ic(iop0+1:iop0+nt)=1   !0:not take H.C. in matrix_vec
          end if
        end if
      end if

c      write(6,*) iop0,kd4(iop),ck4(iop,0)%ntyp
      if(id.eq.1) then
        iop0=iop0+nt
      elseif(id.eq.2) then
        if(kd4(iop).lt.4) then
          do it=1,nt
            iop0=iop0+1
            if(iop0.lt.ista_int.or.iop0.gt.iend_int) cycle
            call make_hamil_4(iop,iop0,it,it)
            call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                   kop(:,iop0),pop(:,iop0))
          end do
        else
          if(ck4(iop,0)%ntyp.eq.1) then
            if(kd4(iop).eq.4) then
              iop0=iop0+1
              if(iop0.ge.ista_int.and.iop0.le.iend_int) then
                call make_hamil_4(iop,iop0,1,2)
                call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                       kop(:,iop0),pop(:,iop0))
              end if
              iop0=iop0+1
              if(iop0.ge.ista_int.and.iop0.le.iend_int) then
                call make_hamil_4(iop,iop0,3,4)
                call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                       kop(:,iop0),pop(:,iop0))
              end if
            elseif(kd4(iop).le.6) then
              iop0=iop0+1
              if(iop0.ge.ista_int.and.iop0.le.iend_int) then
                call make_hamil_4(iop,iop0,1,3)
                call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                       kop(:,iop0),pop(:,iop0))
              end if
              iop0=iop0+1
              if(iop0.ge.ista_int.and.iop0.le.iend_int) then
                call make_hamil_4(iop,iop0,4,6)
                call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                       kop(:,iop0),pop(:,iop0))
              end if
            else
              iop0=iop0+1
              if(iop0.ge.ista_int.and.iop0.le.iend_int) then
                call make_hamil_4(iop,iop0,1,4)
                call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                       kop(:,iop0),pop(:,iop0))
              end if
              iop0=iop0+1
              if(iop0.ge.ista_int.and.iop0.le.iend_int) then
                call make_hamil_4(iop,iop0,5,8)
                call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                       kop(:,iop0),pop(:,iop0))
              end if
            end if
          else
            do it=1,nt
              iop0=iop0+1
              if(iop0.lt.ista_int.or.iop0.gt.iend_int) cycle
              call make_hamil_4(iop,iop0,it,it)
              call para_op(th(1)%kh(iop0),th(1)%kh(iop0),
     &                     kop(:,iop0),pop(:,iop0))
            end do
          end if
        end if
      end if

      return
      end
