      subroutine irand_el(v,n)
      implicit none
      integer :: n
      integer,parameter :: id_dbg0=0
#ifdef cmplx_v
      integer :: ix
      real(8) :: twpi
      real(8),allocatable :: x(:),y(:)
      complex(8) ::
#else
      real(8) ::
#endif
     &  v(n)

#ifdef cmplx_v
      if(id_dbg0.eq.0) then
        twpi=8.d0*atan(1.d0)
        allocate(x(n),y(n))
        call random_number(x(1:n))
        call random_number(y(1:n))
!$OMP PARALLEL DO
        do ix=1,n
          v(ix)=y(ix)*cmplx(cos(twpi*x(ix)),sin(twpi*x(ix)),kind=8)
c          v(ix)=cmplx(cos(twpi*x(ix)),sin(twpi*x(ix)),kind=8)
        enddo
        deallocate(x,y)
      else
        v(1:n)=cmplx(1.d0,0.d0,kind=8)
      end if
#else
      if(id_dbg0.eq.0) then
        call random_number(v(1:n))
!$OMP PARALLEL WORKSHARE
        v(1:n)=v(1:n)-0.5d0
!$OMP END PARALLEL WORKSHARE
      else
!$OMP PARALLEL WORKSHARE
        v(1:n)=1.d0
!$OMP END PARALLEL WORKSHARE
      end if
#endif

      return
      end
