      subroutine lz_state(v0,iv,ieg,nl,vt,mab,v1)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      real(8) :: vt(mab,mab)
      integer :: iv,ieg(*),mab,nl,ib,i,k,ix1,ix2,ih
      type(avec) :: v0(isbk1:iebk1),v1(isbk0:iebk0)
#ifdef cmplx_v
      complex(8) :: c0
#else
      real(8) :: c0
#endif

      ih=1

      if(nl.eq.1) then
#ifdef cmplx_v
        c0=cmplx(vt(1,ieg(iv)),0.d0,kind=8)
#else
        c0=vt(1,ieg(iv))
#endif
!$OMP PARALLEL DO
        do ib=isbk1,iebk1
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
                do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
                  v0(ib)%ap(ad(i,k))%b(ix1,ix2)
     &              =vt(1,ieg(iv))*v1(ib)%ap(ad(i,k))%b(ix1,ix2)
                enddo
              enddo
            enddo
          enddo
        enddo
      else
#ifdef cmplx_v
        c0=cmplx(vt(nl,iv),0.d0,kind=8)
#else
        c0=vt(nl,iv)
#endif
        do ib=isbk1,iebk1
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              if((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &          *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1).gt.0) then
                call XAXPY((bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                    *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                     c0,
     &                     v1(ib)%ap(ad(i,k))%b,1,
     &                     v0(ib)%ap(ad(i,k))%b,1)
              end if
            enddo
          enddo
        enddo
      end if

      return
      end
