      subroutine make_es(nsamp)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: nsamp,i,label,ix
      real(8),allocatable :: esv(:)
      character(64) :: file_esx

      allocate(esv(mts),mpist(MPI_STATUS_SIZE))

      if(myid_dmrg.eq.0) then
        write(file_esx,'(a,I0,a)') 'ES',myid_dmrg_r,'.dat'
        if(myid_dmrg_r.eq.0) open(40,file='ES.dat')
        open(41,file=file_esx)
        do i=1,nsamp
          if(mod(i-1,np_dmrg_r).eq.myid_dmrg_r) then
            read(41,*) esv,label
          end if

          if(mod(i-1,np_dmrg_r).ne.0) then
            if(mod(i-1,np_dmrg_r).eq.myid_dmrg_r) then
              call mpi_send(esv,mts,MPI_REAL8,0,i,newcomm_dmrg_r,ierr)
              call mpi_send(label,1,MPI_INTEGER,0,i,newcomm_dmrg_r,ierr)
            elseif(myid_dmrg_r.eq.0) then
              call mpi_recv(esv,mts,MPI_REAL8,mod(i-1,np_dmrg_r),i,
     &                      newcomm_dmrg_r,mpist,ierr)
              call mpi_recv(label,1,MPI_INTEGER,mod(i-1,np_dmrg_r),i,
     &                      newcomm_dmrg_r,mpist,ierr)
            end if
          end if

          if(myid_dmrg_r.eq.0) then
            do ix=1,mts
              write(40,'(e14.6)',advance='no') esv(ix)
              if(ix.eq.mts) then
                write(40,'(a,1x,I0)',advance='no') ',',label
                write(40,*)
                exit
              else
                write(40,'(a)',advance='no') ','
              end if
            enddo
          end if
        enddo
        close(41)

        if(myid_dmrg_r.eq.0) close(40)
      end if

      deallocate(esv,mpist)

      return
      end
