      subroutine matrix_adjust_s(n,uvi,ib,b,tb,nm)
      use mod_dmrg
      use communication_s,only : get_loop_start,
     &                           get_loop_end
      implicit none
      include 'mpif.h'
      integer :: n,ib,nm,i,j,i_1,i_2,i_3,j_2,j_3,ip
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) :: 
#endif
     &           uvi(ircnt2(myid_(2)+1,ib),ircnt1(myid_(1)+1,ib)),
     &           b(1:nm,*)
#ifdef cmplx_v
      complex(8),allocatable ::
#else
      real(8),allocatable :: 
#endif
     &                       uv1(:,:)
      type(blocks) :: tb

      j_2=get_loop_start(1,size_of_col,my_col)
      j_3=get_loop_end(n,size_of_col,my_col)

      do ip=1,np_(1)
        allocate(uv1(tb%size0(ib),idisp1(ip,ib)+1:
     &               idisp1(ip,ib)+ircnt1(ip,ib)))
        if(myid_(1).eq.ip-1) then
          call gc2d(uvi,ircnt2(myid_(2)+1,ib),
     &              ircnt1(myid_(1)+1,ib),uv1,tb%size0(ib),
     &              np_(2),newcomm_(2))
        end if
        call mpi_bcast(uv1,tb%size0(ib)*ircnt1(ip,ib),
     &                 mpi_kv,ip-1,newcomm_(1),ierr)

        i_2=get_loop_start(idisp1(ip,ib)+1,size_of_row,my_row)
        i_3=get_loop_end(idisp1(ip,ib)+ircnt1(ip,ib),size_of_row,my_row)
        do i_1=i_2,i_3
          i=(i_1-1)*size_of_row+my_row
          j=(j_2-1)*size_of_col+my_col
          call XCOPY(j_3-j_2+1,uv1((j_2-1)*size_of_col+my_col,i),
     &               size_of_col,b(j_2,i_1),1)
        enddo
        deallocate(uv1)
      enddo

      return
      end
