      subroutine mpi_add(v0)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ib,i,k,ir,ia,ih
      integer,allocatable :: nn(:,:,:)
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: vt(:,:)
      type(avec) :: v0(nbk)

      ih=1

      allocate(nn(nfrx(1),nfrx(2),nbk))
      do ib=1,nbk
        if(bmpi(ib)%ic.ne.0) then
          call mpi_allreduce(nv(:,:,ib),nn(:,:,ib),nfrx(1)*nfrx(2),
     &           mpi_integer,mpi_sum,newcomm_add,ierr)
        else
          nn(:,:,ib)=0
        end if
      enddo

      if(np_add.gt.1) then
        allocate(mpist(MPI_STATUS_SIZE))
        do ib=1,nbk
          do k=1,nfrx(2)
            do i=1,nfrx(1)
              if(bmpi(ib)%ic.ne.0) then
                if(bk(ib,2,ih)%sizex(k).gt.0.and.
     &             bk(ib,1,ih)%sizex(i).gt.0) then
                  if(idest_add(i).eq.myid_add) then
                    allocate(vt(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                          bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))
                    if(.not.allocated(v0(ib)%ap(ad(i,k))%b)) then
                      allocate(v0(ib)%ap(ad(i,k))
     &                        %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                           bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))
                      ia=1
                    else
                      ia=0
                    end if
                    do ir=0,np_add-1
                      if(ir.eq.myid_add) cycle
                      if(iand(nn(i,k,ib),ibset(0,ir)).eq.0) cycle
                      call mpi_recv(vt,
     &                     (bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                     *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                     mpi_kv,
     &                     ir,
     &                     (k-1)*nfrx(1)+i,
     &                     newcomm_add,mpist,ierr)
                      if(ia.eq.1) then
                        call XCOPY((bk(ib,1,ih)%ive(i)
     &                               -bk(ib,1,ih)%ivs(i)+1)
     &                            *(bk(ib,2,ih)%ive(k)
     &                               -bk(ib,2,ih)%ivs(k)+1),
     &                             vt,1,
     &                             v0(ib)%ap(ad(i,k))%b,1)
                      else
                        call XAXPY((bk(ib,1,ih)%ive(i)
     &                               -bk(ib,1,ih)%ivs(i)+1)
     &                            *(bk(ib,2,ih)%ive(k)
     &                               -bk(ib,2,ih)%ivs(k)+1),
     &                             one,
     &                             vt,1,
     &                             v0(ib)%ap(ad(i,k))%b,1)
                      end if
                      ia=0
                    enddo
                    if(ia.eq.1) then
!$OMP PARALLEL WORKSHARE
                      v0(ib)%ap(ad(i,k))%b=zero
!$OMP END PARALLEL WORKSHARE
                    end if
                    deallocate(vt)
                  else
                    if(iand(nn(i,k,ib),ibset(0,myid_add)).eq.0) cycle
                    call mpi_send(v0(ib)%ap(ad(i,k))%b,
     &                        (bk(ib,1,ih)%ive(i)-bk(ib,1,ih)%ivs(i)+1)
     &                       *(bk(ib,2,ih)%ive(k)-bk(ib,2,ih)%ivs(k)+1),
     &                         mpi_kv,
     &                         idest_add(i),
     &                         (k-1)*nfrx(1)+i,
     &                         newcomm_add,ierr)
                  end if
                end if
              end if
            enddo
          enddo
        enddo
        deallocate(mpist)
      else
!$OMP PARALLEL DO
        do ib=1,nbk
          do k=1,nfrx(2)
            do i=1,nfrx(1)
              if(bmpi(ib)%ic.ne.0) then
                if(bk(ib,2,ih)%sizex(k).gt.0.and.
     &             bk(ib,1,ih)%sizex(i).gt.0) then
                  if(.not.allocated(v0(ib)%ap(ad(i,k))%b)) then
                    allocate(v0(ib)%ap(ad(i,k))
     &                %b(bk(ib,1,ih)%sizex(i),bk(ib,2,ih)%sizex(k)))
                    v0(ib)%ap(ad(i,k))%b=zero
                  end if
                end if
              end if
            enddo
          enddo
        enddo
      end if

      return
      end
