      subroutine mpi_vec(v0,v1)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ib,i,k,ix1,ix2,lsta,lend,ih
#ifdef cmplx_v
      complex(8),
#else
      real(8),
#endif
     &  allocatable :: temp(:,:)
      type(avec) :: v0(isbk0:iebk0),v1(isbk0:iebk0)

      ih=1

      if(np_vec.eq.1) then
        do ib=isbk0,iebk0
          allocate(v1(ib)%ap(ad(nfrx(1),nfrx(2))))
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              if(bk(ib,1,ih)%sizex(i).gt.0.and.
     &           bk(ib,2,ih)%sizex(k).gt.0) then
                allocate(v1(ib)%ap(ad(i,k))%b(bk(ib,1,ih)%sizex(i),
     &                   bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))

                if(.not.allocated(v0(ib)%ap(ad(i,k))%b)) then
                  allocate(v0(ib)%ap(ad(i,k))
     &                     %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                        bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))
!$OMP PARALLEL WORKSHARE
                  v0(ib)%ap(ad(i,k))%b=zero
!$OMP END PARALLEL WORKSHARE
                end if

                call gc2d(v0(ib)%ap(ad(i,k))%b,
     &                    bk(ib,1,ih)%isz(i),bk(ib,2,ih)%isz(k),
     &                    v1(ib)%ap(ad(i,k))%b,
     &                    bk(ib,1,ih)%sizex(i),np_sys,newcomm_sys)

              end if
            enddo
          enddo
        enddo
      else
        do ib=isbk0,iebk0
          allocate(v1(ib)%ap(ad(nfrx(1),nfrx(2))))
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              if(bk(ib,1,ih)%sizex(i).gt.0.and.
     &           bk(ib,2,ih)%sizex(k).gt.0) then
                call para_range(1,bk(ib,1,ih)%sizex(i),np_vec,myid_vec,
     &                          lsta,lend)
                allocate(v1(ib)%ap(ad(i,k))%b(lsta:lend,
     &                        bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))
                allocate(temp(bk(ib,1,ih)%sizex(i),
     &                        bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))

                if(.not.allocated(v0(ib)%ap(ad(i,k))%b)) then
                  allocate(v0(ib)%ap(ad(i,k))
     &                     %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                        bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))
!$OMP PARALLEL WORKSHARE
                  v0(ib)%ap(ad(i,k))%b=zero
!$OMP END PARALLEL WORKSHARE
                end if

                call gc2d(v0(ib)%ap(ad(i,k))%b,
     &                    bk(ib,1,ih)%isz(i),bk(ib,2,ih)%isz(k),
     &                    temp,
     &                    bk(ib,1,ih)%sizex(i),np_sys,newcomm_sys)
!$OMP PARALLEL DO
                do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
                  do ix1=lsta,lend
                    v1(ib)%ap(ad(i,k))%b(ix1,ix2)=temp(ix1,ix2)
                  enddo
                enddo

                deallocate(temp)

              end if
            enddo
          enddo
        enddo
      end if

      return
      end
