      subroutine mv_env(id,vin,vout,bp,pp,cf)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: id,ib,jb,i0,i1,k0,k1,lsta,lend,lsize,ih
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  cf,zz
      type(avec) :: vin(isbk0:iebk0),vout(nbk)
      type(bop) :: bp(2),pp(*)

      ih=1

      do ib=isbk0,iebk0
        jb=bp(1)%jbk(ib)
        if(jb.eq.0) cycle
        do i0=1,nfrx(1)
          do k0=1,nfrx(2)
            i1=bp(1)%io(i0)
            k1=bp(2)%io(k0)
            if(i1*k1.eq.0) cycle

            if(bk(ib,1,ih)%sizex(i0)*bk(ib,2,ih)%sizex(k0).ne.0.and.
     &         bk(jb,1,ih)%sizex(i1)*bk(jb,2,ih)%sizex(k1).ne.0) then

              call vclear(vout(jb),nv(i1,k1,jb),i1,k1,
     &                    bk(jb,1,ih)%ivs(i1),bk(jb,1,ih)%ive(i1),
     &                    bk(jb,2,ih)%sizex(k1))

              call para_ranges(1,bk(jb,2,ih)%sizex(k1),np_vec,myid_vec,
     &                         lsta,lend,lsize)

              if(bk(ib,2,ih)%isz(k0)*bk(jb,1,ih)%isz(i1)
     &               *lsize.ne.0) then

                zz=bp(2)%fs(k0)*bp(1)%vo(i0)*bp(2)%vo(k0)*cf

                call XGEMM(chmm(1),chmm(2),
     &                    bk(jb,1,ih)%isz(i1),
     &                    lsize,
     &                    bk(ib,2,ih)%isz(k0),
     &                    zz,
     &                    vin(ib)%ap(ad(i0,k0))%b,
     &                    bk(jb,1,ih)%isz(i1),
     &                    pp(1)%bt(bk(ib,1,ih)%ap(ad(i0,k0))%nse(2))%op,
     &                    lsize,
     &                    one,
     &                    vout(jb)%ap(ad(i1,k1))%b(:,lsta),
     &                    bk(jb,1,ih)%isz(i1))
              end if

            end if
          enddo
        enddo
      enddo

      return
      end
