      subroutine mv_init(vin,vout,ista_bk,iend_bk)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ista_bk,iend_bk,ib,k,i,ix1,ix2,ih
      type(avec) :: vin(ista_bk:iend_bk),vout(nbk)

      ih=1

      if(myid_vec.eq.0) then
        do ib=ista_bk,iend_bk
          do k=1,nfrx(2)
            do i=1,nfrx(1)
              if(bk(ib,1,ih)%sizex(i).gt.0.and.
     &           bk(ib,2,ih)%sizex(k).gt.0) then
                nv(i,k,ib)=ibset(0,myid_add)
                if(.not.allocated(vout(ib)%ap(ad(i,k))%b)) then
                  allocate(vout(ib)%ap(ad(i,k))
     &              %b(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                 bk(ib,2,ih)%sizex(k)))
                else
                  cycle
                end if
!$OMP PARALLEL
!$OMP DO
                do ix2=1,bk(ib,2,ih)%ivs(k)-1
                  do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
                    vout(ib)%ap(ad(i,k))%b(ix1,ix2)=zero
                  enddo
                enddo
!$OMP END DO NOWAIT
!$OMP DO
                do ix2=bk(ib,2,ih)%ivs(k),bk(ib,2,ih)%ive(k)
                  do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
                    vout(ib)%ap(ad(i,k))%b(ix1,ix2)
     &                =vin(ib)%ap(ad(i,k))%b(ix1,ix2)
                  enddo
                enddo
!$OMP END DO NOWAIT
!$OMP DO
                do ix2=bk(ib,2,ih)%ive(k)+1,bk(ib,2,ih)%sizex(k)
                  do ix1=bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i)
                    vout(ib)%ap(ad(i,k))%b(ix1,ix2)=zero
                  enddo
                enddo
!$OMP END DO
!$OMP END PARALLEL
              end if
            enddo
          enddo
        enddo
      else
        do ib=ista_bk,iend_bk
          do k=1,nfrx(2)
            do i=1,nfrx(1)
              if(bk(ib,1,ih)%sizex(i).gt.0.and.
     &           bk(ib,2,ih)%sizex(k).gt.0) then

                call vclear(vout(ib),nv(i,k,ib),i,k,
     &                      bk(ib,1,ih)%ivs(i),bk(ib,1,ih)%ive(i),
     &                      bk(ib,2,ih)%sizex(k))

              end if
            enddo
          enddo
        enddo
      end if

      return
      end
