      subroutine para_op(id,ic,kopx,popx)
      use mod_dmrg
      implicit none
      integer :: id,ic,ib,jb,i0,k0,i1,k1,i,k,lsta,lend,
     &           ksta,kend,ksize,ih
#ifdef cmplx_v
      complex(8),allocatable ::
#else
      real(8),allocatable ::
#endif
     &    tmp(:,:)
      type(bop) :: kopx(2),popx(4)

      ih=1

      if(id.eq.0) then !system and environment block
        allocate(popx(1)%bt(block(1,nse(1),mh)%nbk))
        do ib=isbk0,iebk0
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              if(bk(ib,1,ih)%sizex(i).gt.0.and.
     &           bk(ib,2,ih)%sizex(k).gt.0) then
                if(.not.allocated(popx(1)
     &                     %bt(bk(ib,1,ih)%ap(ad(i,k))%nse(1))%op)) then

                  call para_range(1,bk(ib,1,ih)%sizex(i),np_vec,
     &                            myid_vec,lsta,lend)
                  call para_ranges(lsta,lend,np_env,myid_env,ksta,kend,
     &                             ksize)

                  allocate(tmp(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),
     &                         ksta:kend))

                  call XCOPY(bk(ib,1,ih)%isz(i)*ksize,
     &                       block(1,nse(1),mh)%b(bk(ib,1,ih)
     &                       %ap(ad(i,k))%nse(1))%hm,1,tmp,1)

! ----- LASER PULSE
#ifdef cmplx_v
                  if(if_tdmrg.eq.1) then
                    if(tdmrg(itdmrg)%ks.eq.1) then
                      call XAXPY(bk(ib,1,ih)%isz(i)*ksize,ps-one,
     &                         block(1,nse(1),mh)%b(bk(ib,1,ih)
     &                         %ap(ad(i,k))%nse(1))%hmt(:,:,1),1,tmp,1)

                      call XAXPY(bk(ib,1,ih)%isz(i)*ksize,conjg(ps-one),
     &                         block(1,nse(1),mh)%b(bk(ib,1,ih)
     &                         %ap(ad(i,k))%nse(1))%hmt(:,:,2),1,tmp,1)
                    end if
                  end if
#endif

                  allocate(popx(1)%bt(bk(ib,1,ih)%ap(ad(i,k))%nse(1))
     &             %op(bk(ib,1,ih)%ivs(i):bk(ib,1,ih)%ive(i),lsta:lend))
                  mem_op=mem_op+8*size(popx(1)
     &                          %bt(bk(ib,1,ih)%ap(ad(i,k))%nse(1))%op)
                  call gr2d(tmp,bk(ib,1,ih)%isz(i)*(kend-ksta+1),
     &                      popx(1)%bt(bk(ib,1,ih)%ap(ad(i,k))%nse(1))
     &                      %op,np_env,newcomm_env)

                  deallocate(tmp)
                end if
              end if
            enddo
          enddo
        enddo

        allocate(popx(2)%bt(block(2,nse(2),mh)%nbk))
        do ib=isbk0,iebk0
          do i=1,nfrx(1)
            do k=1,nfrx(2)
              if(bk(ib,1,ih)%sizex(i).gt.0.and.
     &           bk(ib,2,ih)%sizex(k).gt.0) then
                if(.not.allocated(popx(2)
     &                     %bt(bk(ib,1,ih)%ap(ad(i,k))%nse(2))%op)) then

                  call para_range(1,bk(ib,2,ih)%sizex(k),np_vec,
     &                            myid_vec,lsta,lend)
                  call para_ranges(lsta,lend,np_sys,myid_sys,ksta,kend,
     &                             ksize)

                  allocate(tmp(ksta:kend,
     &                         bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))

                  call XCOPY(bk(ib,2,ih)%isz(k)*ksize,
     &                       block(2,nse(2),mh)%b(bk(ib,1,ih)
     &                         %ap(ad(i,k))%nse(2))%hm,1,tmp,1)

! ----- LASER PULSE
#ifdef cmplx_v
                  if(if_tdmrg.eq.1) then
                    if(tdmrg(itdmrg)%ks.eq.1) then
                      call XAXPY(bk(ib,2,ih)%isz(k)*ksize,conjg(ps-one),
     &                         block(2,nse(2),mh)%b(bk(ib,1,ih)
     &                         %ap(ad(i,k))%nse(2))%hmt(:,:,1),1,tmp,1)

                      call XAXPY(bk(ib,2,ih)%isz(k)*ksize,ps-one,
     &                         block(2,nse(2),mh)%b(bk(ib,1,ih)
     &                         %ap(ad(i,k))%nse(2))%hmt(:,:,2),1,tmp,1)
                    end if
                  end if
#endif

                  allocate(popx(2)%bt(bk(ib,1,ih)%ap(ad(i,k))%nse(2))
     &             %op(lsta:lend,bk(ib,2,ih)%ivs(k):bk(ib,2,ih)%ive(k)))
                  mem_op=mem_op+8*size(popx(2)
     &                          %bt(bk(ib,1,ih)%ap(ad(i,k))%nse(2))%op)
                  call gc2d(tmp,kend-ksta+1,bk(ib,2,ih)%isz(k),
     &                    popx(2)%bt(bk(ib,1,ih)%ap(ad(i,k))%nse(2))%op,
     &                    lend-lsta+1,np_sys,newcomm_sys)
                  deallocate(tmp)
                end if
              end if
            enddo
          enddo
        enddo

      elseif(id.eq.1.or.id.eq.3) then
        allocate(popx(1)%bt(block(1,nse(1),mh)%nbk))
        do ib=isbk0,iebk0
          jb=kopx(1)%jbk(ib)
          if(jb.eq.0) cycle
          do i0=1,nfrx(1)
            do k0=1,nfrx(2)
              i1=kopx(1)%io(i0)
              k1=kopx(2)%io(k0)
              if(i1*k1.eq.0) cycle
              if(bk(ib,1,ih)%sizex(i0).gt.0.and.
     &           bk(ib,2,ih)%sizex(k0).gt.0.and.
     &           bk(jb,1,ih)%sizex(i1).gt.0.and.
     &           bk(jb,2,ih)%sizex(k1).gt.0) then

                call pop_maker(kopx(1),popx(1),ib,jb,i1,k1,i0,k0,0,ic)

              end if
            enddo
          enddo
        enddo

        if(ic.eq.0) return

        if(.not.allocated(kopx(2)%jbk)) then
          allocate(kopx(2)%jbk(nbk))
!$OMP PARALLEL WORKSHARE
          kopx(2)%jbk=0
!$OMP END PARALLEL WORKSHARE
!$OMP PARALLEL DO
          do ib=1,nbk
            if(kopx(1)%jbk(ib).eq.0) cycle
            kopx(2)%jbk(kopx(1)%jbk(ib))=ib
          enddo
        end if

        allocate(popx(2)%bt(block(1,nse(1),mh)%nbk))
        do ib=isbk0,iebk0
          jb=kopx(2)%jbk(ib)
          if(jb.eq.0) cycle
          do i0=1,nfrx(1)
            do k0=1,nfrx(2)
              i1=kopx(1)%io(i0)
              k1=kopx(2)%io(k0)
              if(i1*k1.eq.0) cycle
              if(bk(jb,1,ih)%sizex(i0).gt.0.and.
     &           bk(ib,2,ih)%sizex(k1).gt.0.and.
     &           bk(ib,1,ih)%sizex(i1).gt.0.and.
     &           bk(jb,2,ih)%sizex(k0).gt.0) then

                call pop_maker(kopx(1),popx(2),ib,jb,i1,k1,i0,k0,1,0)

              end if

            enddo
          enddo
        enddo

      elseif(id.eq.2.or.id.eq.4) then
        allocate(popx(1)%bt(block(2,nse(2),mh)%nbk))
        do ib=isbk0,iebk0
          jb=kopx(1)%jbk(ib)
          if(jb.eq.0) cycle
          do i0=1,nfrx(1)
            do k0=1,nfrx(2)
              i1=kopx(1)%io(i0)
              k1=kopx(2)%io(k0)
              if(i1*k1.eq.0) cycle
              if(bk(jb,1,ih)%sizex(i1).gt.0.and.
     &           bk(ib,2,ih)%sizex(k0).gt.0.and.
     &           bk(ib,1,ih)%sizex(i0).gt.0.and.
     &           bk(jb,2,ih)%sizex(k1).gt.0) then

                call pop_maker(kopx(2),popx(1),ib,jb,i1,k1,i0,k0,2,ic)

              end if
            enddo
          enddo
        enddo

        if(ic.eq.0) return

        if(.not.allocated(kopx(2)%jbk)) then
          allocate(kopx(2)%jbk(nbk))
!$OMP PARALLEL WORKSHARE
          kopx(2)%jbk=0
!$OMP END PARALLEL WORKSHARE
!$OMP PARALLEL DO
          do ib=1,nbk
            if(kopx(1)%jbk(ib).eq.0) cycle
            kopx(2)%jbk(kopx(1)%jbk(ib))=ib
          enddo
        end if

        allocate(popx(2)%bt(block(2,nse(2),mh)%nbk))
        do ib=isbk0,iebk0
          jb=kopx(2)%jbk(ib)
          if(jb.eq.0) cycle
          do i0=1,nfrx(1)
            do k0=1,nfrx(2)
              i1=kopx(1)%io(i0)
              k1=kopx(2)%io(k0)
              if(i1*k1.eq.0) cycle
              if(bk(ib,1,ih)%sizex(i1).gt.0.and.
     &           bk(ib,2,ih)%sizex(k1).gt.0.and.
     &           bk(jb,1,ih)%sizex(i0).gt.0.and.
     &           bk(jb,2,ih)%sizex(k0).gt.0) then

                call pop_maker(kopx(2),popx(2),ib,jb,i1,k1,i0,k0,3,0)

              end if
            enddo
          enddo
        enddo

      elseif(id.eq.5) then
        allocate(popx(1)%bt(block(1,nse(1),mh)%nbk))
        allocate(popx(2)%bt(block(2,nse(2),mh)%nbk))
        do ib=isbk0,iebk0
          jb=kopx(1)%jbk(ib)
          if(jb.eq.0) cycle
          do i0=1,nfrx(1)
            do k0=1,nfrx(2)
              i1=kopx(1)%io(i0)
              k1=kopx(2)%io(k0)
              if(i1*k1.eq.0) cycle
              if(bk(jb,1,ih)%sizex(i1).gt.0.and.
     &           bk(ib,2,ih)%sizex(k0).gt.0.and.
     &           bk(ib,1,ih)%sizex(i0).gt.0.and.
     &           bk(jb,2,ih)%sizex(k1).gt.0) then

                call pop_maker(kopx(1),popx(1),ib,jb,i1,k1,i0,k0,0,ic)

                call pop_maker(kopx(2),popx(2),ib,jb,i1,k1,i0,k0,2,ic)

              end if
            enddo
          enddo
        enddo

        if(.not.allocated(kopx(2)%jbk)) then
          allocate(kopx(2)%jbk(nbk))
!$OMP PARALLEL WORKSHARE
          kopx(2)%jbk=0
!$OMP END PARALLEL WORKSHARE
!$OMP PARALLEL DO
          do ib=1,nbk
            if(kopx(1)%jbk(ib).eq.0) cycle
            kopx(2)%jbk(kopx(1)%jbk(ib))=ib
          enddo
        end if

        if(ic.eq.0) return

        allocate(popx(3)%bt(block(1,nse(1),mh)%nbk))
        allocate(popx(4)%bt(block(2,nse(2),mh)%nbk))
        do ib=isbk0,iebk0
          jb=kopx(2)%jbk(ib)
          if(jb.eq.0) cycle
          do i0=1,nfrx(1)
            do k0=1,nfrx(2)
              i1=kopx(1)%io(i0)
              k1=kopx(2)%io(k0)
              if(i1*k1.eq.0) cycle
              if(bk(jb,1,ih)%sizex(i0).gt.0.and.
     &           bk(ib,2,ih)%sizex(k1).gt.0.and.
     &           bk(ib,1,ih)%sizex(i1).gt.0.and.
     &           bk(jb,2,ih)%sizex(k0).gt.0) then

                call pop_maker(kopx(1),popx(3),ib,jb,i1,k1,i0,k0,1,0)

                call pop_maker(kopx(2),popx(4),ib,jb,i1,k1,i0,k0,3,0)

              end if
            enddo
          enddo
        enddo
      end if

      return
      end
