      subroutine single_op(ms1,ks1,ops)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ms1,ks1(ms1),ix,ix1,ix2
#ifdef cmplx_v
      complex(8) ::
#else
      real(8) ::
#endif
     &  ops(nfr,nfr),opst(nfr,nfr,2)

!$OMP PARALLEL DO PRIVATE(ix1,ix2)
      do ix=1,nfr*nfr
        ix1=mod(ix-1,nfr)+1
        ix2=(ix-1)/nfr+1
        if(ix1.eq.ix2) then
          opst(ix1,ix2,1)=one
        else
          opst(ix1,ix2,1)=zero
        end if
      enddo

      do ix=1,ms1
        if(ks1(ix).ge.1) then
#ifdef cmplx_v
          call XGEMM(chmm(1),chmm(1),
     &              nfr,nfr,nfr,one,opst(:,:,mod(ix-1,2)+1),nfr,
     &              opz(:,:,ks1(ix)),nfr,zero,opst(:,:,mod(ix,2)+1),nfr)
#else
          call XGEMM(chmm(1),chmm(1),
     &              nfr,nfr,nfr,one,opst(:,:,mod(ix-1,2)+1),nfr,
     &              op(:,:,ks1(ix)),nfr,zero,opst(:,:,mod(ix,2)+1),nfr)
#endif
        elseif(ks1(ix).le.-1) then
#ifdef cmplx_v
          call XGEMM(chmm(1),chmm(2),
     &           nfr,nfr,nfr,one,opst(:,:,mod(ix-1,2)+1),nfr,
     &           opz(:,:,-ks1(ix)),nfr,zero,opst(:,:,mod(ix,2)+1),nfr)
#else
          call XGEMM(chmm(1),chmm(2),
     &           nfr,nfr,nfr,one,opst(:,:,mod(ix-1,2)+1),nfr,
     &           op(:,:,-ks1(ix)),nfr,zero,opst(:,:,mod(ix,2)+1),nfr)
#endif
        end if
      enddo

      call XCOPY(nfr*nfr,opst(:,:,mod(ms1,2)+1),1,ops,1)

      return
      end
