      subroutine sys_init_read()
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ix

      if(myid_dmrg.eq.key_rank) then
        open(10,file='system.ini',status='old',form='unformatted',
     &       err=999)
        read(10) id_spin,id_spinless,nfr,nop,nit,nhcf,mhcf
      end if
      call mpi_bcast(id_spin,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(id_spinless,1,mpi_integer,key_rank,newcomm_dmrg,
     &               ierr)
      call mpi_bcast(nfr,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(nop,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(nit,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(nhcf,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(mhcf,1,mpi_integer,key_rank,newcomm_dmrg,ierr)

      allocate(iud(nfr,2),op(nfr,nfr,nop),iht(2,nit),ht(nit),ihm(nit),
     &         kch(0:nop),kud(nit),fsi(0:nit),nch(2,nop),
     &         name_op(-nop:nop),ihcf(mhcf))

      if(myid_dmrg.eq.key_rank) then
        read(10) iud,op,iht,ht,ihm,kch,kud,iftp,fsi,nch,ihcf
        do ix=-nop,nop
          read(10) name_op(ix)
        enddo
        close(10)
      end if

      call mpi_bcast(iud,nfr*2,mpi_integer,key_rank,newcomm_dmrg,ierr)
      do ix=-nop,nop
        call mpi_bcast(name_op(ix),16,mpi_character,key_rank,
     &                 newcomm_dmrg,ierr)
      enddo
      call mpi_bcast(op,nfr*nfr*nop,MPI_REAL8,key_rank,newcomm_dmrg,
     &               ierr)
      call mpi_bcast(iht,2*nit,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(ht,nit,MPI_REAL8,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(ihm,nit,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(kch,1+nop,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(kud,nit,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(iftp,1,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(fsi,1+nit,MPI_REAL8,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(nch,2*nop,mpi_integer,key_rank,newcomm_dmrg,ierr)
      call mpi_bcast(ihcf,mhcf,mpi_integer,key_rank,newcomm_dmrg,ierr)

      return

  999 continue

      call mpi_abort(newcomm_dmrg,ierr)

      stop
      end
