      subroutine trans_set_op(ise,nx,mhx,ib,iop0,lsta,lend,n)
      use mod_dmrg
      implicit none
      include 'mpif.h'
      integer :: ise,nx,ib,iop0,i0,i1,jsta,jend,ista,iend,
     &           isize,jsize,mhx,ix1,ix2,n,lsta(*),lend(*)
#ifdef cmplx_v
      complex(8) :: zz
      complex(8),
#else
      real(8) :: zz
      real(8),
#endif
     &  allocatable :: tmp(:,:),opt(:,:)


      do i0=1,nfr
        i1=kop(ise,iop0)%io(i0)
        if(i1.eq.0) cycle
        if(block(ise,nx,mhx)%nse(ib,i0).ne.0.and.
     &     block(ise,nx,mhx)%nse(ib,i1).ne.0) then

          allocate(opt(block(ise,nx,mhx)%sizex(ib,i1),
     &                 block(ise,nx,mhx)%sizex(ib,i0)))

          select case(ise)
          case(1)
            if(block(ise,nx,mhx)%sizex(ib,i1).eq.0) return
            call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i0),
     &                       np_vec,myid_vec,jsta,jend,jsize)
            allocate(tmp(block(ise,nx,mhx)%sizex(ib,i1),jsta:jend))
            call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i1),
     &                       np_sys,myid_sys,ista,iend,isize)

            if(.not.allocated(pop(1,iop0)%bt(block(ise,nx,mhx)
     &                          %nse(ib,i0))%op)) then
              allocate(pop(1,iop0)%bt(block(ise,nx,mhx)
     &                 %nse(ib,i0))%op(ista:iend,jsta:jend))
!$OMP PARALLEL WORKSHARE
              pop(1,iop0)%bt(block(ise,nx,mhx)%nse(ib,i0))%op=zero
!$OMP END PARALLEL WORKSHARE
            end if

            call gc2d(pop(1,iop0)%bt(block(ise,nx,mhx)%nse(ib,i0))
     &                %op(:,jsta),isize,jsize,tmp,
     &                block(ise,nx,mhx)%sizex(ib,i1),np_sys,newcomm_sys)

            call gr2d(tmp,size(tmp),opt,np_vec,newcomm_vec)
            deallocate(tmp)

          case(2)
            if(block(ise,nx,mhx)%sizex(ib,i0).eq.0) return
            call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i1),
     &                       np_vec,myid_vec,jsta,jend,jsize)
            call para_ranges(1,block(ise,nx,mhx)%sizex(ib,i0),
     &                       np_env,myid_env,ista,iend,isize)

            if(.not.allocated(pop(1,iop0)%bt(block(ise,nx,mhx)
     &                        %nse(ib,i0))%op)) then
              allocate(pop(1,iop0)%bt(block(ise,nx,mhx)
     &                 %nse(ib,i0))%op(jsta:jend,ista:iend))
!$OMP PARALLEL WORKSHARE
              pop(1,iop0)%bt(block(ise,nx,mhx)%nse(ib,i0))%op=zero
!$OMP END PARALLEL WORKSHARE
            end if

            allocate(tmp(block(ise,nx,mhx)%sizex(ib,i1),ista:iend))

            call gc2d(pop(1,iop0)%bt(block(ise,nx,mhx)%nse(ib,i0))
     &                  %op(:,ista:),jsize,isize,tmp,
     &                block(ise,nx,mhx)%sizex(ib,i1),
     &                np_vec,newcomm_vec)

            call gr2d(tmp,size(tmp),opt,np_env,newcomm_env)
            deallocate(tmp)
          end select

#ifdef cmplx_v
          if(ise.eq.1) then
            zz=kop(ise,iop0)%vo(i0)
          else
            zz=conjg(kop(ise,iop0)%vo(i0))
          end if
#else
          zz=kop(ise,iop0)%vo(i0)
#endif
          if(n.eq.0.or.n.eq.1) then
!$OMP PARALLEL DO
            do ix1=1,block(ise,nx,mhx)%sizex(ib,i0)
              do ix2=lsta(i1),lend(i1)
                ast(i1,1)
     &            %ht(ix2,ix1+block(ise,nx,mhx)%stax(ib,i0)-1)
     &         =ast(i1,1)
     &            %ht(ix2,ix1+block(ise,nx,mhx)%stax(ib,i0)-1)
     &          +zz*opt(ix2,ix1)
              enddo
            enddo
          end if

          if(n.eq.0) then
            if(th(1)%ic(iop0).eq.0) then
              deallocate(opt)
              cycle
            end if
          end if

          if(n.eq.0.or.n.eq.2) then
!$OMP PARALLEL DO
            do ix1=1,block(ise,nx,mhx)%sizex(ib,i1)
              do ix2=lsta(i0),lend(i0)
                ast(i0,1)
     &            %ht(ix2,ix1+block(ise,nx,mhx)%stax(ib,i1)-1)
     &         =ast(i0,1)
     &            %ht(ix2,ix1+block(ise,nx,mhx)%stax(ib,i1)-1)
#ifdef cmplx_v
     &          +conjg(zz*opt(ix1,ix2))
#else
     &          +kop(ise,iop0)%vo(i0)*opt(ix1,ix2)
#endif
              enddo
            enddo
          end if

          deallocate(opt)
        end if
      enddo

      return
      end
